{
    This unit is the interface of the compiler which can be used by
    external programs to link in the compiler

    Copyright (c) 1998-2005 by Florian Klaempfl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************}

unit compiler;

{$i fpcdefs.inc}

{ some units are implicitly needed by the compiler }
{$WARN 5023 off : Unit "$1" not used in $2}

interface

uses
systems,
  fpwidestring,
{$IFNDEF USE_FAKE_SYSUTILS}
  sysutils,math,
{$ELSE}
  fksysutl,
{$ENDIF}
  verbose,comphook,//wpo,
  cutils,cclasses,globals,options,fmodule,parser,symtable,
  assemble,link,export,tokens
  ,cpupara
  ,cpupi
,psystem
,scandir,scanner
  ,cgcpu
  ,globtype
      ,elf
       ,rax64att
,rax86int
,nx86cnv
       ,ncgbas,
       ncgld,
       ncgflw,
       ncgcnv,
       ncgmem,
       ncgmat,
       ncgcon,
       ncgcal,
       ncgset,
       symcpu,
       aasmdef,
       nx86set,
       nx86con,
       nx86mem,
       nx64add,
       nx86ld,
       nx64cal,
       nx64inl,
       nx64set
;

function Compile(const cmd:TCmdStr):longint;

implementation

function Compile(const cmd:TCmdStr):longint;

{$maxfpuregisters 0}

begin
  try
    try

       SetExceptionMask([exInvalidOp, exDenormalized, exZeroDivide,
                         exOverflow, exUnderflow, exPrecision]);


  DefaultSystemCodePage:=CP_UTF8;
  read_arguments('');
  InitScanner; InitScannerDirectives;
  registernodes; registertais;

        parser.compile(inputfilepath+inputfilename);

       if status.errorcount=0 then
        begin
           result:=0;
        end else result:=1;
     finally
       halt;
     end;
  except
    halt;
  end;
end;

end.
