{
    Copyright (c) 1998-2002 by Florian Klaempfl and Peter Vreman

    Contains the base types for the i8086, i386 and x86-64 architecture

    * This code was inspired by the NASM sources
      The Netwide Assembler is Copyright (c) 1996 Simon Tatham and
      Julian Hall. All rights reserved.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************
}
unit cpubase;

{$i fpcdefs.inc}

interface

uses
  globals,
  cgbase
  ;

    type
      TAsmOp=
(
A_NONE,
A_ADC,
A_ADD,
A_AND,
A_BSF,
A_BSR,
A_BSWAP,
A_BT,
A_BTC,
A_BTR,
A_BTS,
A_CALL,
A_CBW,
A_CDQ,
A_CLC,
A_CLD,
A_CLI,
A_CLTS,
A_CMC,
A_CMP,
A_CMPSB,
A_CMPSD,
A_CMPSW,
A_CMPXCHG,
A_CMPXCHG486,
A_CMPXCHG8B,
A_CPUID,
A_CWD,
A_CWDE,
A_DEC,
A_DIV,
A_EMMS,
A_ENTER,
A_F2XM1,
A_FABS,
A_FADD,
A_FADDP,
A_FBLD,
A_FBSTP,
A_FCHS,
A_FCLEX,
A_FCMOVB,
A_FCMOVBE,
A_FCMOVE,
A_FCMOVNB,
A_FCMOVNBE,
A_FCMOVNE,
A_FCMOVNU,
A_FCMOVU,
A_FCOM,
A_FCOMI,
A_FCOMIP,
A_FCOMP,
A_FCOMPP,
A_FCOS,
A_FDECSTP,
A_FDISI,
A_FDIV,
A_FDIVP,
A_FDIVR,
A_FDIVRP,
A_FEMMS,
A_FENI,
A_FFREE,
A_FIADD,
A_FICOM,
A_FICOMP,
A_FIDIV,
A_FIDIVR,
A_FILD,
A_FIMUL,
A_FINCSTP,
A_FINIT,
A_FIST,
A_FISTP,
A_FISTTP,
A_FISUB,
A_FISUBR,
A_FLD,
A_FLD1,
A_FLDCW,
A_FLDENV,
A_FLDL2E,
A_FLDL2T,
A_FLDLG2,
A_FLDLN2,
A_FLDPI,
A_FLDZ,
A_FMUL,
A_FMULP,
A_FNCLEX,
A_FNDISI,
A_FNENI,
A_FNINIT,
A_FNOP,
A_FNSAVE,
A_FNSTCW,
A_FNSTENV,
A_FNSTSW,
A_FPATAN,
A_FPREM,
A_FPREM1,
A_FPTAN,
A_FRNDINT,
A_FRSTOR,
A_FSAVE,
A_FSCALE,
A_FSETPM,
A_FSIN,
A_FSINCOS,
A_FSQRT,
A_FST,
A_FSTCW,
A_FSTENV,
A_FSTP,
A_FSTSW,
A_FSUB,
A_FSUBP,
A_FSUBR,
A_FSUBRP,
A_FTST,
A_FUCOM,
A_FUCOMI,
A_FUCOMIP,
A_FUCOMP,
A_FUCOMPP,
A_FWAIT,
A_FXAM,
A_FXCH,
A_FXTRACT,
A_FYL2X,
A_FYL2XP1,
A_HLT,
A_IBTS,
A_ICEBP,
A_IDIV,
A_IMUL,
A_IN,
A_INC,
A_INSB,
A_INSD,
A_INSW,
A_INT,
A_INT01,
A_INT1,
A_INT03,
A_INT3,
A_INVD,
A_INVLPG,
A_IRET,
A_IRETD,
A_IRETW,
A_IRETQ,
A_JECXZ,
A_JRCXZ,
A_JMP,
A_LAHF,
A_LAR,
A_LCALL,
A_LEA,
A_LEAVE,
A_LFS,
A_LGDT,
A_LGS,
A_LIDT,
A_LJMP,
A_LLDT,
A_LMSW,
A_LOADALL,
A_LOADALL286,
A_LOCK,
A_LODSB,
A_LODSD,
A_LODSW,
A_LOOP,
A_LOOPE,
A_LOOPNE,
A_LOOPNZ,
A_LOOPZ,
A_LSL,
A_LSS,
A_LTR,
A_MONITOR,
A_MOV,
A_MOVD,
A_MOVQ,
A_MOVSB,
A_MOVSD,
A_MOVSQ,
A_MOVSW,
A_MOVSX,
A_MOVZX,
A_MUL,
A_MWAIT,
A_NEG,
A_NOP,
A_NOT,
A_OR,
A_OUT,
A_OUTSB,
A_OUTSD,
A_OUTSW,
A_PACKSSDW,
A_PACKSSWB,
A_PACKUSWB,
A_PADDB,
A_PADDD,
A_PADDSB,
A_PADDSIW,
A_PADDSW,
A_PADDUSB,
A_PADDUSW,
A_PADDW,
A_PAND,
A_PANDN,
A_PAVEB,
A_PAVGUSB,
A_PCMPEQB,
A_PCMPEQD,
A_PCMPEQW,
A_PCMPGTB,
A_PCMPGTD,
A_PCMPGTW,
A_PDISTIB,
A_PF2ID,
A_PFACC,
A_PFADD,
A_PFCMPEQ,
A_PFCMPGE,
A_PFCMPGT,
A_PFMAX,
A_PFMIN,
A_PFMUL,
A_PFRCP,
A_PFRCPIT1,
A_PFRCPIT2,
A_PFRSQIT1,
A_PFRSQRT,
A_PFSUB,
A_PFSUBR,
A_PI2FD,
A_PMACHRIW,
A_PMADDWD,
A_PMAGW,
A_PMULHRIW,
A_PMULHRWA,
A_PMULHRWC,
A_PMULHW,
A_PMULLW,
A_PMVGEZB,
A_PMVLZB,
A_PMVNZB,
A_PMVZB,
A_POP,
A_POPF,
A_POPFW,
A_POPFQ,
A_POR,
A_PREFETCH,
A_PREFETCHW,
A_PSLLD,
A_PSLLDQ,
A_PSLLQ,
A_PSLLW,
A_PSRAD,
A_PSRAW,
A_PSRLD,
A_PSRLQ,
A_PSRLW,
A_PSUBB,
A_PSUBD,
A_PSUBSB,
A_PSUBSIW,
A_PSUBSW,
A_PSUBUSB,
A_PSUBUSW,
A_PSUBW,
A_PUNPCKHBW,
A_PUNPCKHDQ,
A_PUNPCKHWD,
A_PUNPCKLBW,
A_PUNPCKLDQ,
A_PUNPCKLWD,
A_PUSH,
A_PUSHF,
A_PUSHFW,
A_PUSHFQ,
A_PXOR,
A_RCL,
A_RCR,
A_RDSHR,
A_RDMSR,
A_RDPMC,
A_RDTSC,
A_REP,
A_REPE,
A_REPNE,
A_REPNZ,
A_REPZ,
A_RET,
A_RETF,
A_RETN,
A_RETW,
A_RETFW,
A_RETNW,
A_RETFD,
A_RETQ,
A_RETFQ,
A_RETNQ,
A_ROL,
A_ROR,
A_RSDC,
A_RSLDT,
A_RSM,
A_SAHF,
A_SAL,
A_SAR,
A_SBB,
A_SCASB,
A_SCASD,
A_SCASQ,
A_SCASW,
A_SEGCS,
A_SEGDS,
A_SEGES,
A_SEGFS,
A_SEGGS,
A_SEGSS,
A_SGDT,
A_SHL,
A_SHLD,
A_SHR,
A_SHRD,
A_SIDT,
A_SLDT,
A_SMI,
A_SMINT,
A_SMINTOLD,
A_SMSW,
A_STC,
A_STD,
A_STI,
A_STOSB,
A_STOSD,
A_STOSW,
A_STR,
A_SUB,
A_SVDC,
A_SVLDT,
A_SVTS,
A_SYSCALL,
A_SYSENTER,
A_SYSEXIT,
A_SYSRET,
A_TEST,
A_UD1,
A_UD2,
A_UMOV,
A_VERR,
A_VERW,
A_WAIT,
A_WBINVD,
A_WRSHR,
A_WRMSR,
A_XADD,
A_XBTS,
A_XCHG,
A_XLAT,
A_XLATB,
A_XOR,
A_XSTORE,
A_XCRYPTECB,
A_XCRYPTCBC,
A_XCRYPTCFB,
A_XCRYPTOFB,
A_CMOVcc,
A_Jcc,
A_SETcc,
A_MOVS,
A_CMPS,
A_SCAS,
A_LODS,
A_STOS,
A_INS,
A_OUTS,
A_ADDPS,
A_ADDSS,
A_ANDNPS,
A_ANDPS,
A_CMPEQPS,
A_CMPEQSS,
A_CMPLEPS,
A_CMPLESS,
A_CMPLTPS,
A_CMPLTSS,
A_CMPNEQPS,
A_CMPNEQSS,
A_CMPNLEPS,
A_CMPNLESS,
A_CMPNLTPS,
A_CMPNLTSS,
A_CMPORDPS,
A_CMPORDSS,
A_CMPUNORDPS,
A_CMPUNORDSS,
A_CMPPS,
A_CMPSS,
A_COMISS,
A_CVTPI2PS,
A_CVTPS2PI,
A_CVTSI2SS,
A_CVTSS2SI,
A_CVTTPS2PI,
A_CVTTSS2SI,
A_DIVPS,
A_DIVSS,
A_LDMXCSR,
A_MAXPS,
A_MAXSS,
A_MINPS,
A_MINSS,
A_MOVAPS,
A_MOVHPS,
A_MOVLHPS,
A_MOVLPS,
A_MOVHLPS,
A_MOVMSKPS,
A_MOVNTPS,
A_MOVSS,
A_MOVUPS,
A_MULPS,
A_MULSS,
A_ORPS,
A_RCPPS,
A_RCPSS,
A_RSQRTPS,
A_RSQRTSS,
A_SHUFPS,
A_SQRTPS,
A_SQRTSS,
A_STMXCSR,
A_SUBPS,
A_SUBSS,
A_UCOMISS,
A_UNPCKHPS,
A_UNPCKLPS,
A_XORPS,
A_FXRSTOR,
A_FXSAVE,
A_PREFETCHNTA,
A_PREFETCHT0,
A_PREFETCHT1,
A_PREFETCHT2,
A_SFENCE,
A_MASKMOVQ,
A_MOVNTQ,
A_PAVGB,
A_PAVGW,
A_PEXTRW,
A_PINSRW,
A_PMAXSW,
A_PMAXUB,
A_PMINSW,
A_PMINUB,
A_PMOVMSKB,
A_PMULHUW,
A_PSADBW,
A_PSHUFW,
A_PFNACC,
A_PFPNACC,
A_PI2FW,
A_PF2IW,
A_PSWAPD,
A_FFREEP,
A_MASKMOVDQU,
A_CLFLUSH,
A_MOVNTDQ,
A_MOVNTI,
A_MOVNTPD,
A_PAUSE,
A_LFENCE,
A_MFENCE,
A_MOVDQA,
A_MOVDQU,
A_MOVDQ2Q,
A_MOVQ2DQ,
A_PADDQ,
A_PMULUDQ,
A_PSHUFD,
A_PSHUFHW,
A_PSHUFLW,
A_PSRLDQ,
A_PSUBQ,
A_PUNPCKHQDQ,
A_PUNPCKLQDQ,
A_ADDPD,
A_ADDSD,
A_ANDNPD,
A_ANDPD,
A_CMPEQPD,
A_CMPEQSD,
A_CMPLEPD,
A_CMPLESD,
A_CMPLTPD,
A_CMPLTSD,
A_CMPNEQPD,
A_CMPNEQSD,
A_CMPNLEPD,
A_CMPNLESD,
A_CMPNLTPD,
A_CMPNLTSD,
A_CMPORDPD,
A_CMPORDSD,
A_CMPUNORDPD,
A_CMPUNORDSD,
A_CMPPD,
A_COMISD,
A_CVTDQ2PD,
A_CVTDQ2PS,
A_CVTPD2DQ,
A_CVTPD2PI,
A_CVTPD2PS,
A_CVTPI2PD,
A_CVTPS2DQ,
A_CVTPS2PD,
A_CVTSD2SI,
A_CVTSD2SS,
A_CVTSI2SD,
A_CVTSS2SD,
A_CVTTPD2PI,
A_CVTTPD2DQ,
A_CVTTPS2DQ,
A_CVTTSD2SI,
A_DIVPD,
A_DIVSD,
A_MAXPD,
A_MAXSD,
A_MINPD,
A_MINSD,
A_MOVAPD,
A_MOVHPD,
A_MOVLPD,
A_MOVMSKPD,
A_MOVUPD,
A_MULPD,
A_MULSD,
A_ORPD,
A_SHUFPD,
A_SQRTPD,
A_SQRTSD,
A_SUBPD,
A_SUBSD,
A_UCOMISD,
A_UNPCKHPD,
A_UNPCKLPD,
A_XORPD,
A_ADDSUBPD,
A_ADDSUBPS,
A_HADDPD,
A_HADDPS,
A_HSUBPD,
A_HSUBPS,
A_LDDQU,
A_MOVDDUP,
A_MOVSHDUP,
A_MOVSLDUP,
A_VMREAD,
A_VMWRITE,
A_VMCALL,
A_VMLAUNCH,
A_VMRESUME,
A_VMXOFF,
A_VMXON,
A_VMCLEAR,
A_VMPTRLD,
A_VMPTRST,
A_VMRUN,
A_VMMCALL,
A_VMLOAD,
A_VMSAVE,
A_STGI,
A_CLGI,
A_SKINIT,
A_INVLPGA,
A_MONTMUL,
A_XSHA1,
A_XSHA256,
A_DMINT,
A_RDM,
A_MOVABS,
A_MOVSXD,
A_CQO,
A_CDQE,
A_CMPXCHG16B,
A_MOVNTSS,
A_MOVNTSD,
A_INSERTQ,
A_EXTRQ,
A_LZCNT,
A_PABSB,
A_PABSW,
A_PABSD,
A_PALIGNR,
A_PHADDW,
A_PHADDD,
A_PHADDSW,
A_PHSUBW,
A_PHSUBD,
A_PHSUBSW,
A_PMADDUBSW,
A_PMULHRSW,
A_PSHUFB,
A_PSIGNB,
A_PSIGNW,
A_PSIGND,
A_BLENDPS,
A_BLENDPD,
A_BLENDVPS,
A_BLENDVPD,
A_DPPS,
A_DPPD,
A_EXTRACTPS,
A_INSERTPS,
A_MOVNTDQA,
A_MPSADBW,
A_PACKUSDW,
A_PBLENDVB,
A_PBLENDW,
A_PCMPEQQ,
A_PEXTRB,
A_PEXTRD,
A_PEXTRQ,
A_PHMINPOSUW,
A_PINSRB,
A_PINSRD,
A_PINSRQ,
A_PMAXSB,
A_PMAXSD,
A_PMAXUD,
A_PMAXUW,
A_PMINSB,
A_PMINSD,
A_PMINUW,
A_PMINUD,
A_PMOVSXBW,
A_PMOVSXBD,
A_PMOVSXBQ,
A_PMOVSXWD,
A_PMOVSXWQ,
A_PMOVSXDQ,
A_PMOVZXBW,
A_PMOVZXBD,
A_PMOVZXBQ,
A_PMOVZXWD,
A_PMOVZXWQ,
A_PMOVZXDQ,
A_PMULDQ,
A_PMULLD,
A_PTEST,
A_ROUNDPS,
A_ROUNDPD,
A_ROUNDSS,
A_ROUNDSD,
A_CRC32,
A_PCMPESTRI,
A_PCMPESTRM,
A_PCMPISTRI,
A_PCMPISTRM,
A_PCMPGTQ,
A_POPCNT,
A_AESENC,
A_AESENCLAST,
A_AESDEC,
A_AESDECLAST,
A_AESIMC,
A_AESKEYGENASSIST,
A_RDTSCP,
A_STOSQ,
A_LODSQ,
A_CMPSQ,
A_MOVBE,
A_PCLMULQDQ,
A_VADDPD,
A_VADDPS,
A_VADDSD,
A_VADDSS,
A_VADDSUBPD,
A_VADDSUBPS,
A_VAESDEC,
A_VAESDECLAST,
A_VAESENC,
A_VAESENCLAST,
A_VAESIMC,
A_VAESKEYGENASSIST,
A_VANDNPD,
A_VANDNPS,
A_VANDPD,
A_VANDPS,
A_VBLENDPD,
A_VBLENDPS,
A_VBLENDVPD,
A_VBLENDVPS,
A_VBROADCASTF128,
A_VBROADCASTSD,
A_VBROADCASTSS,
A_VCMPEQPS,
A_VCMPLTPS,
A_VCMPLEPS,
A_VCMPUNORDPS,
A_VCMPNEQPS,
A_VCMPNLTPS,
A_VCMPNLEPS,
A_VCMPORDPS,
A_VCMPEQ_UQPS,
A_VCMPNGEPS,
A_VCMPNGTPS,
A_VCMPFALSEPS,
A_VCMPNEQ_OQPS,
A_VCMPGEPS,
A_VCMPGTPS,
A_VCMPTRUEPS,
A_VCMPEQ_OSPS,
A_VCMPLT_OQPS,
A_VCMPLE_OQPS,
A_VCMPUNORD_SPS,
A_VCMPNEQ_USPS,
A_VCMPNLT_UQPS,
A_VCMPNLE_UQPS,
A_VCMPORD_SPS,
A_VCMPEQ_USPS,
A_VCMPNGE_UQPS,
A_VCMPNGT_UQPS,
A_VCMPFALSE_OSPS,
A_VCMPNEQ_OSPS,
A_VCMPGE_OQPS,
A_VCMPGT_OQPS,
A_VCMPTRUE_USPS,
A_VCMPEQPD,
A_VCMPLTPD,
A_VCMPLEPD,
A_VCMPUNORDPD,
A_VCMPNEQPD,
A_VCMPNLTPD,
A_VCMPNLEPD,
A_VCMPORDPD,
A_VCMPEQ_UQPD,
A_VCMPNGEPD,
A_VCMPNGTPD,
A_VCMPFALSEPD,
A_VCMPNEQ_OQPD,
A_VCMPGEPD,
A_VCMPGTPD,
A_VCMPTRUEPD,
A_VCMPEQ_OSPD,
A_VCMPLT_OQPD,
A_VCMPLE_OQPD,
A_VCMPUNORD_SPD,
A_VCMPNEQ_USPD,
A_VCMPNLT_UQPD,
A_VCMPNLE_UQPD,
A_VCMPORD_SPD,
A_VCMPEQ_USPD,
A_VCMPNGE_UQPD,
A_VCMPNGT_UQPD,
A_VCMPFALSE_OSPD,
A_VCMPNEQ_OSPD,
A_VCMPGE_OQPD,
A_VCMPGT_OQPD,
A_VCMPTRUE_USPD,
A_VCMPPD,
A_VCMPPS,
A_VCMPSD,
A_VCMPSS,
A_VCOMISD,
A_VCOMISS,
A_VCVTDQ2PD,
A_VCVTDQ2PS,
A_VCVTPD2DQ,
A_VCVTPD2PS,
A_VCVTPH2PS,
A_VCVTPS2DQ,
A_VCVTPS2PD,
A_VCVTPS2PH,
A_VCVTSD2SI,
A_VCVTSD2SS,
A_VCVTSI2SD,
A_VCVTSI2SS,
A_VCVTSS2SD,
A_VCVTSS2SI,
A_VCVTTPD2DQ,
A_VCVTTPS2DQ,
A_VCVTTSD2SI,
A_VCVTTSS2SI,
A_VDIVPD,
A_VDIVPS,
A_VDIVSD,
A_VDIVSS,
A_VDPPD,
A_VDPPS,
A_VEXTRACTF128,
A_VEXTRACTPS,
A_VHADDPD,
A_VHADDPS,
A_VHSUBPD,
A_VHSUBPS,
A_VINSERTF128,
A_VINSERTPS,
A_VLDDQU,
A_VLDMXCSR,
A_VMASKMOVDQU,
A_VMASKMOVPD,
A_VMASKMOVPS,
A_VMAXPD,
A_VMAXPS,
A_VMAXSD,
A_VMAXSS,
A_VMINPD,
A_VMINPS,
A_VMINSD,
A_VMINSS,
A_VMOVAPD,
A_VMOVAPS,
A_VMOVD,
A_VMOVDDUP,
A_VMOVDQA,
A_VMOVDQU,
A_VMOVHLPS,
A_VMOVHPD,
A_VMOVHPS,
A_VMOVLHPS,
A_VMOVLPD,
A_VMOVLPS,
A_VMOVMSKPD,
A_VMOVMSKPS,
A_VMOVNTDQ,
A_VMOVNTDQA,
A_VMOVNTPD,
A_VMOVNTPS,
A_VMOVQ,
A_VMOVSD,
A_VMOVSHDUP,
A_VMOVSLDUP,
A_VMOVSS,
A_VMOVUPD,
A_VMOVUPS,
A_VMPSADBW,
A_VMULPD,
A_VMULPS,
A_VMULSD,
A_VMULSS,
A_VORPD,
A_VORPS,
A_VPABSB,
A_VPABSD,
A_VPABSW,
A_VPACKSSDW,
A_VPACKSSWB,
A_VPACKUSDW,
A_VPACKUSWB,
A_VPADDB,
A_VPADDD,
A_VPADDQ,
A_VPADDSB,
A_VPADDSW,
A_VPADDUSB,
A_VPADDUSW,
A_VPADDW,
A_VPALIGNR,
A_VPAND,
A_VPANDN,
A_VPAVGB,
A_VPAVGW,
A_VPBLENDVB,
A_VPBLENDW,
A_VPCLMULQDQ,
A_VPCMPEQB,
A_VPCMPEQD,
A_VPCMPEQQ,
A_VPCMPEQW,
A_VPCMPESTRI,
A_VPCMPESTRM,
A_VPCMPGTB,
A_VPCMPGTD,
A_VPCMPGTQ,
A_VPCMPGTW,
A_VPCMPISTRI,
A_VPCMPISTRM,
A_VPERM2F128,
A_VPERMILPD,
A_VPERMILPS,
A_VPEXTRB,
A_VPEXTRD,
A_VPEXTRQ,
A_VPEXTRW,
A_VPHADDD,
A_VPHADDSW,
A_VPHADDW,
A_VPHMINPOSUW,
A_VPHSUBD,
A_VPHSUBSW,
A_VPHSUBW,
A_VPINSRB,
A_VPINSRD,
A_VPINSRQ,
A_VPINSRW,
A_VPMADDUBSW,
A_VPMADDWD,
A_VPMAXSB,
A_VPMAXSD,
A_VPMAXSW,
A_VPMAXUB,
A_VPMAXUD,
A_VPMAXUW,
A_VPMINSB,
A_VPMINSD,
A_VPMINSW,
A_VPMINUB,
A_VPMINUD,
A_VPMINUW,
A_VPMOVMSKB,
A_VPMOVSXBD,
A_VPMOVSXBQ,
A_VPMOVSXBW,
A_VPMOVSXDQ,
A_VPMOVSXWD,
A_VPMOVSXWQ,
A_VPMOVZXBD,
A_VPMOVZXBQ,
A_VPMOVZXBW,
A_VPMOVZXDQ,
A_VPMOVZXWD,
A_VPMOVZXWQ,
A_VPMULDQ,
A_VPMULHRSW,
A_VPMULHUW,
A_VPMULHW,
A_VPMULLD,
A_VPMULLW,
A_VPMULUDQ,
A_VPOR,
A_VPSADBW,
A_VPSHUFB,
A_VPSHUFD,
A_VPSHUFHW,
A_VPSHUFLW,
A_VPSIGNB,
A_VPSIGND,
A_VPSIGNW,
A_VPSLLD,
A_VPSLLDQ,
A_VPSLLQ,
A_VPSLLW,
A_VPSRAD,
A_VPSRAW,
A_VPSRLD,
A_VPSRLDQ,
A_VPSRLQ,
A_VPSRLW,
A_VPSUBB,
A_VPSUBD,
A_VPSUBQ,
A_VPSUBSB,
A_VPSUBSW,
A_VPSUBUSB,
A_VPSUBUSW,
A_VPSUBW,
A_VPTEST,
A_VPUNPCKHBW,
A_VPUNPCKHDQ,
A_VPUNPCKHQDQ,
A_VPUNPCKHWD,
A_VPUNPCKLBW,
A_VPUNPCKLDQ,
A_VPUNPCKLQDQ,
A_VPUNPCKLWD,
A_VPXOR,
A_VRCPPS,
A_VRCPSS,
A_VROUNDPD,
A_VROUNDPS,
A_VROUNDSD,
A_VROUNDSS,
A_VRSQRTPS,
A_VRSQRTSS,
A_VSHUFPD,
A_VSHUFPS,
A_VSQRTPD,
A_VSQRTPS,
A_VSQRTSD,
A_VSQRTSS,
A_VSTMXCSR,
A_VSUBPD,
A_VSUBPS,
A_VSUBSD,
A_VSUBSS,
A_VTESTPD,
A_VTESTPS,
A_VUCOMISD,
A_VUCOMISS,
A_VUNPCKHPD,
A_VUNPCKHPS,
A_VUNPCKLPD,
A_VUNPCKLPS,
A_VXORPD,
A_VXORPS,
A_VZEROALL,
A_VZEROUPPER,
A_ANDN,
A_BEXTR,
A_BLSI,
A_BLSMSK,
A_BLSR,
A_TZCNT,
A_BZHI,
A_MULX,
A_PDEP,
A_PEXT,
A_RORX,
A_SARX,
A_SHLX,
A_SHRX,
A_ADCX,
A_ADOX,
A_VBROADCASTI128,
A_VEXTRACTI128,
A_VINSERTI128,
A_VPBLENDD,
A_VPBROADCASTB,
A_VPBROADCASTD,
A_VPBROADCASTQ,
A_VPBROADCASTW,
A_VPERM2I128,
A_VPERMD,
A_VPERMPD,
A_VPERMPS,
A_VPERMQ,
A_VPMASKMOVD,
A_VPMASKMOVQ,
A_VPSLLVD,
A_VPSLLVQ,
A_VPSRAVD,
A_VPSRLVD,
A_VPSRLVQ,
A_VGATHERDPD,
A_VGATHERDPS,
A_VGATHERQPD,
A_VGATHERQPS,
A_VPGATHERDD,
A_VPGATHERDQ,
A_VPGATHERQD,
A_VPGATHERQQ,
A_VFMADDPD,
A_VFMADD132PD,
A_VFMADD132PS,
A_VFMADD132SD,
A_VFMADD132SS,
A_VFMADD213PD,
A_VFMADD213PS,
A_VFMADD213SD,
A_VFMADD213SS,
A_VFMADD231PD,
A_VFMADD231PS,
A_VFMADD231SD,
A_VFMADD231SS,
A_VFMADDSUB132PD,
A_VFMADDSUB132PS,
A_VFMADDSUB213PD,
A_VFMADDSUB213PS,
A_VFMADDSUB231PD,
A_VFMADDSUB231PS,
A_VFMSUB132PD,
A_VFMSUB132PS,
A_VFMSUB132SD,
A_VFMSUB132SS,
A_VFMSUB213PD,
A_VFMSUB213PS,
A_VFMSUB213SD,
A_VFMSUB213SS,
A_VFMSUB231PD,
A_VFMSUB231PS,
A_VFMSUB231SD,
A_VFMSUB231SS,
A_VFMSUBADD132PD,
A_VFMSUBADD132PS,
A_VFMSUBADD213PD,
A_VFMSUBADD213PS,
A_VFMSUBADD231PD,
A_VFMSUBADD231PS,
A_VFNMADD132PD,
A_VFNMADD132PS,
A_VFNMADD132SD,
A_VFNMADD132SS,
A_VFNMADD213PD,
A_VFNMADD213PS,
A_VFNMADD213SD,
A_VFNMADD213SS,
A_VFNMADD231PD,
A_VFNMADD231PS,
A_VFNMADD231SD,
A_VFNMADD231SS,
A_VFNMSUB132PD,
A_VFNMSUB132PS,
A_VFNMSUB132SD,
A_VFNMSUB132SS,
A_VFNMSUB213PD,
A_VFNMSUB213PS,
A_VFNMSUB213SD,
A_VFNMSUB213SS,
A_VFNMSUB231PD,
A_VFNMSUB231PS,
A_VFNMSUB231SD,
A_VFNMSUB231SS,
A_XACQUIRE,
A_XRELEASE,
A_XBEGIN,
A_XABORT,
A_XEND,
A_XTEST,
A_RDRAND,
A_RDSEED,
A_XGETBV,
A_XSETBV,
A_XSAVE,
A_XSAVE64,
A_XRSTOR,
A_XRSTOR64,
A_XSAVEOPT,
A_XSAVEOPT64,
A_PREFETCHWT1,
A_KADDB,
A_KADDD,
A_KADDQ,
A_KADDW,
A_KANDB,
A_KANDD,
A_KANDNB,
A_KANDND,
A_KANDNQ,
A_KANDNW,
A_KANDQ,
A_KANDW,
A_KMOVB,
A_KMOVD,
A_KMOVQ,
A_KMOVW,
A_KNOTB,
A_KNOTD,
A_KNOTQ,
A_KNOTW,
A_KORB,
A_KORD,
A_KORQ,
A_KORTESTB,
A_KORTESTD,
A_KORTESTQ,
A_KORTESTW,
A_KORW,
A_KSHIFTLB,
A_KSHIFTLD,
A_KSHIFTLQ,
A_KSHIFTLW,
A_KSHIFTRB,
A_KSHIFTRD,
A_KSHIFTRQ,
A_KSHIFTRW,
A_KTESTB,
A_KTESTD,
A_KTESTQ,
A_KTESTW,
A_KUNPCKBW,
A_KUNPCKDQ,
A_KUNPCKWD,
A_KXNORB,
A_KXNORD,
A_KXNORQ,
A_KXNORW,
A_KXORB,
A_KXORD,
A_KXORQ,
A_KXORW,
A_VALIGND,
A_VALIGNQ,
A_VBLENDMPD,
A_VBLENDMPS,
A_VBROADCASTF32X2,
A_VBROADCASTF32X4,
A_VBROADCASTF32X8,
A_VBROADCASTF64X2,
A_VBROADCASTF64X4,
A_VBROADCASTI32X2,
A_VBROADCASTI32X4,
A_VBROADCASTI32X8,
A_VBROADCASTI64X2,
A_VBROADCASTI64X4,
A_VCOMPRESSPD,
A_VCOMPRESSPS,
A_VCVTPD2QQ,
A_VCVTPD2UDQ,
A_VCVTPD2UQQ,
A_VCVTPS2QQ,
A_VCVTPS2UDQ,
A_VCVTPS2UQQ,
A_VCVTQQ2PD,
A_VCVTQQ2PS,
A_VCVTSD2USI,
A_VCVTSS2USI,
A_VCVTTPD2QQ,
A_VCVTTPD2UDQ,
A_VCVTTPD2UQQ,
A_VCVTTPS2QQ,
A_VCVTTPS2UDQ,
A_VCVTTPS2UQQ,
A_VCVTTSD2USI,
A_VCVTTSS2USI,
A_VCVTUDQ2PD,
A_VCVTUDQ2PS,
A_VCVTUQQ2PD,
A_VCVTUQQ2PS,
A_VCVTUSI2SD,
A_VCVTUSI2SS,
A_VDBPSADBW,
A_VEXP2PD,
A_VEXP2PS,
A_VEXPANDPD,
A_VEXPANDPS,
A_VEXTRACTF32X4,
A_VEXTRACTF32X8,
A_VEXTRACTF64X2,
A_VEXTRACTF64X4,
A_VEXTRACTI32X4,
A_VEXTRACTI32X8,
A_VEXTRACTI64X2,
A_VEXTRACTI64X4,
A_VFIXUPIMMPD,
A_VFIXUPIMMPS,
A_VFIXUPIMMSD,
A_VFIXUPIMMSS,
A_VFPCLASSPD,
A_VFPCLASSPS,
A_VFPCLASSSD,
A_VFPCLASSSS,
A_VGETEXPPD,
A_VGETEXPPS,
A_VGETEXPSD,
A_VGETEXPSS,
A_VGETMANTPD,
A_VGETMANTPS,
A_VGETMANTSD,
A_VGETMANTSS,
A_VINSERTF32X4,
A_VINSERTF32X8,
A_VINSERTF64X2,
A_VINSERTF64X4,
A_VINSERTI32X4,
A_VINSERTI32X8,
A_VINSERTI64X2,
A_VINSERTI64X4,
A_VMOVDQA32,
A_VMOVDQA64,
A_VMOVDQU16,
A_VMOVDQU32,
A_VMOVDQU64,
A_VMOVDQU8,
A_VPABSQ,
A_VPANDD,
A_VPANDND,
A_VPANDNQ,
A_VPANDQ,
A_VPBLENDMB,
A_VPBLENDMD,
A_VPBLENDMQ,
A_VPBLENDMW,
A_VPCMPB,
A_VPCMPD,
A_VPCMPQ,
A_VPCMPUB,
A_VPCMPUD,
A_VPCMPUQ,
A_VPCMPUW,
A_VPCMPW,
A_VPCOMPRESSD,
A_VPCOMPRESSQ,
A_VPCONFLICTD,
A_VPCONFLICTQ,
A_VPERMB,
A_VPERMI2B,
A_VPERMI2D,
A_VPERMI2PD,
A_VPERMI2PS,
A_VPERMI2Q,
A_VPERMI2W,
A_VPERMT2B,
A_VPERMT2D,
A_VPERMT2PD,
A_VPERMT2PS,
A_VPERMT2Q,
A_VPERMT2W,
A_VPERMW,
A_VPEXPANDD,
A_VPEXPANDQ,
A_VPLZCNTD,
A_VPLZCNTQ,
A_VPMADD52HUQ,
A_VPMADD52LUQ,
A_VPMAXSQ,
A_VPMAXUQ,
A_VPMINSQ,
A_VPMINUQ,
A_VPMOVB2M,
A_VPMOVD2M,
A_VPMOVDB,
A_VPMOVDW,
A_VPMOVM2B,
A_VPMOVM2D,
A_VPMOVM2Q,
A_VPMOVM2W,
A_VPMOVQ2M,
A_VPMOVQB,
A_VPMOVQD,
A_VPMOVQW,
A_VPMOVSDB,
A_VPMOVSDW,
A_VPMOVSQB,
A_VPMOVSQD,
A_VPMOVSQW,
A_VPMOVSWB,
A_VPMOVUSDB,
A_VPMOVUSDW,
A_VPMOVUSQB,
A_VPMOVUSQD,
A_VPMOVUSQW,
A_VPMOVUSWB,
A_VPMOVW2M,
A_VPMOVWB,
A_VPMULLQ,
A_VPMULTISHIFTQB,
A_VPORD,
A_VPORQ,
A_VPROLD,
A_VPROLQ,
A_VPROLVD,
A_VPROLVQ,
A_VPRORD,
A_VPRORQ,
A_VPRORVD,
A_VPRORVQ,
A_VPSCATTERDD,
A_VPSCATTERDQ,
A_VPSCATTERQD,
A_VPSCATTERQQ,
A_VPSLLVW,
A_VPSRAQ,
A_VPSRAVQ,
A_VPSRAVW,
A_VPSRLVW,
A_VPTERNLOGD,
A_VPTERNLOGQ,
A_VPTESTMB,
A_VPTESTMD,
A_VPTESTMQ,
A_VPTESTMW,
A_VPTESTNMB,
A_VPTESTNMD,
A_VPTESTNMQ,
A_VPTESTNMW,
A_VPXORD,
A_VPXORQ,
A_VRANGEPD,
A_VRANGEPS,
A_VRANGESD,
A_VRANGESS,
A_VRCP14PD,
A_VRCP14PS,
A_VRCP14SD,
A_VRCP14SS,
A_VRCP28PD,
A_VRCP28PS,
A_VRCP28SD,
A_VRCP28SS,
A_VREDUCEPD,
A_VREDUCEPS,
A_VREDUCESD,
A_VREDUCESS,
A_VRNDSCALEPD,
A_VRNDSCALEPS,
A_VRNDSCALESD,
A_VRNDSCALESS,
A_VRSQRT14PD,
A_VRSQRT14PS,
A_VRSQRT14SD,
A_VRSQRT14SS,
A_VRSQRT28PD,
A_VRSQRT28PS,
A_VRSQRT28SD,
A_VRSQRT28SS,
A_VSCALEFPD,
A_VSCALEFPS,
A_VSCALEFSD,
A_VSCALEFSS,
A_VSCATTERDPD,
A_VSCATTERDPS,
A_VSCATTERQPD,
A_VSCATTERQPS,
A_VSHUFF32X4,
A_VSHUFF64X2,
A_VSHUFI32X4,
A_VSHUFI64X2,
A_VPCOMPRESSB,
A_VPCOMPRESSW,
A_VPDPBUSD,
A_VPDPBUSDS,
A_VPDPWSSD,
A_VPDPWSSDS,
A_VPEXPANDB,
A_VPEXPANDW,
A_VPOPCNTB,
A_VPOPCNTD,
A_VPOPCNTQ,
A_VPOPCNTW,
A_VPSHLDD,
A_VPSHLDQ,
A_VPSHLDVD,
A_VPSHLDVQ,
A_VPSHLDVW,
A_VPSHLDW,
A_VPSHRDD,
A_VPSHRDQ,
A_VPSHRDVD,
A_VPSHRDVQ,
A_VPSHRDVW,
A_VPSHRDW,
A_VPSHUFBITQMB,
A_SHA1RNDS4,
A_SHA1NEXTE,
A_SHA1MSG1,
A_SHA1MSG2,
A_SHA256RNDS2,
A_SHA256MSG1,
A_SHA256MSG2
);

      { This should define the array of instructions as string }
        op2strtable=array[tasmop] of string[16];

      ImmInt = Longint;

    const
      { First value of opcode enumeration }
      firstop = low(tasmop);
      { Last value of opcode enumeration  }
      lastop  = high(tasmop);

{*****************************************************************************
                                  Registers
*****************************************************************************}

   const
      { Integer Super registers }
      RS_NO         = $ffffffff;
      RS_RAX        = $00;      {EAX}
      RS_RCX        = $01;      {ECX}
      RS_RDX        = $02;      {EDX}
      RS_RBX        = $03;      {EBX}
      RS_RSI        = $04;      {ESI}
      RS_RDI        = $05;      {EDI}
      RS_RBP        = $06;      {EBP}
      RS_RSP        = $07;      {ESP}
      RS_R8         = $08;      {R8}
      RS_R9         = $09;      {R9}
      RS_R10        = $0a;      {R10}
      RS_R11        = $0b;      {R11}
      RS_R12        = $0c;      {R12}
      RS_R13        = $0d;      {R13}
      RS_R14        = $0e;      {R14}
      RS_R15        = $0f;      {R15}
      { create aliases to allow code sharing between x86-64 and i386 }
      RS_EAX        = RS_RAX;
      RS_EBX        = RS_RBX;
      RS_ECX        = RS_RCX;
      RS_EDX        = RS_RDX;
      RS_ESI        = RS_RSI;
      RS_EDI        = RS_RDI;
      RS_EBP        = RS_RBP;
      RS_ESP        = RS_RSP;
      { create aliases to allow code sharing between i386 and i8086 }
      RS_AX        = RS_RAX;
      RS_BX        = RS_RBX;
      RS_CX        = RS_RCX;
      RS_DX        = RS_RDX;
      RS_SI        = RS_RSI;
      RS_DI        = RS_RDI;
      RS_BP        = RS_RBP;
      RS_SP        = RS_RSP;

      { Number of first imaginary register }
      first_int_imreg     = $10;

      { Float Super registers }
      RS_ST0        = $00;
      RS_ST1        = $01;
      RS_ST2        = $02;
      RS_ST3        = $03;
      RS_ST4        = $04;
      RS_ST5        = $05;
      RS_ST6        = $06;
      RS_ST7        = $07;
      RS_ST         = $08;

      { Number of first imaginary register }
      first_fpu_imreg     = $09;

      { MM Super registers }
      RS_XMM0        = $00;
      RS_XMM1        = $01;
      RS_XMM2        = $02;
      RS_XMM3        = $03;
      RS_XMM4        = $04;
      RS_XMM5        = $05;
      RS_XMM6        = $06;
      RS_XMM7        = $07;
      RS_XMM8        = $08;
      RS_XMM9        = $09;
      RS_XMM10       = $0a;
      RS_XMM11       = $0b;
      RS_XMM12       = $0c;
      RS_XMM13       = $0d;
      RS_XMM14       = $0e;
      RS_XMM15       = $0f;
      RS_XMM16       = $10;
      RS_XMM17       = $11;
      RS_XMM18       = $12;
      RS_XMM19       = $13;
      RS_XMM20       = $14;
      RS_XMM21       = $15;
      RS_XMM22       = $16;
      RS_XMM23       = $17;
      RS_XMM24       = $18;
      RS_XMM25       = $19;
      RS_XMM26       = $1a;
      RS_XMM27       = $1b;
      RS_XMM28       = $1c;
      RS_XMM29       = $1d;
      RS_XMM30       = $1e;
      RS_XMM31       = $1f;

      RS_RFLAGS      = $06;

      { Number of first imaginary register }
      first_mm_imreg     = $20;

      { The subregister that specifies the entire register and an address }
      { Hammer }
      R_SUBWHOLE    = R_SUBQ;
      R_SUBADDR     = R_SUBQ;

      { Available Registers }
NR_NO = tregister($00000000);
NR_AL = tregister($01010000);
NR_AH = tregister($01020000);
NR_AX = tregister($01030000);
NR_EAX = tregister($01040000);
NR_RAX = tregister($01050000);
NR_CL = tregister($01010001);
NR_CH = tregister($01020001);
NR_CX = tregister($01030001);
NR_ECX = tregister($01040001);
NR_RCX = tregister($01050001);
NR_DL = tregister($01010002);
NR_DH = tregister($01020002);
NR_DX = tregister($01030002);
NR_EDX = tregister($01040002);
NR_RDX = tregister($01050002);
NR_BL = tregister($01010003);
NR_BH = tregister($01020003);
NR_BX = tregister($01030003);
NR_EBX = tregister($01040003);
NR_RBX = tregister($01050003);
NR_SIL = tregister($01010004);
NR_SI = tregister($01030004);
NR_ESI = tregister($01040004);
NR_RSI = tregister($01050004);
NR_DIL = tregister($01010005);
NR_DI = tregister($01030005);
NR_EDI = tregister($01040005);
NR_RDI = tregister($01050005);
NR_BPL = tregister($01010006);
NR_BP = tregister($01030006);
NR_EBP = tregister($01040006);
NR_RBP = tregister($01050006);
NR_SPL = tregister($01010007);
NR_SP = tregister($01030007);
NR_ESP = tregister($01040007);
NR_RSP = tregister($01050007);
NR_R8 = tregister($01050008);
NR_R8L = tregister($01010008);
NR_R8W = tregister($01030008);
NR_R8D = tregister($01040008);
NR_R9 = tregister($01050009);
NR_R9L = tregister($01010009);
NR_R9W = tregister($01030009);
NR_R9D = tregister($01040009);
NR_R10 = tregister($0105000a);
NR_R10L = tregister($0101000a);
NR_R10W = tregister($0103000a);
NR_R10D = tregister($0104000a);
NR_R11 = tregister($0105000b);
NR_R11L = tregister($0101000b);
NR_R11W = tregister($0103000b);
NR_R11D = tregister($0104000b);
NR_R12 = tregister($0105000c);
NR_R12L = tregister($0101000c);
NR_R12W = tregister($0103000c);
NR_R12D = tregister($0104000c);
NR_R13 = tregister($0105000d);
NR_R13L = tregister($0101000d);
NR_R13W = tregister($0103000d);
NR_R13D = tregister($0104000d);
NR_R14 = tregister($0105000e);
NR_R14L = tregister($0101000e);
NR_R14W = tregister($0103000e);
NR_R14D = tregister($0104000e);
NR_R15 = tregister($0105000f);
NR_R15L = tregister($0101000f);
NR_R15W = tregister($0103000f);
NR_R15D = tregister($0104000f);
NR_ES = tregister($05000000);
NR_CS = tregister($05000001);
NR_SS = tregister($05000002);
NR_DS = tregister($05000003);
NR_FS = tregister($05000004);
NR_GS = tregister($05000005);
NR_FLAGS = tregister($05030006);
NR_EFLAGS = tregister($05040006);
NR_RFLAGS = tregister($05050006);
NR_CARRYFLAG = tregister($050f0006);
NR_PARITYFLAG = tregister($05100006);
NR_AUXILIARYFLAG = tregister($05110006);
NR_ZEROFLAG = tregister($05120006);
NR_SIGNFLAG = tregister($05130006);
NR_OVERFLOWFLAG = tregister($05140006);
NR_INTERRUPTFLAG = tregister($05150006);
NR_DIRECTIONFLAG = tregister($05160006);
NR_RIP = tregister($05050007);
NR_EIP = tregister($05040007);
NR_DR0 = tregister($05000008);
NR_DR1 = tregister($05000009);
NR_DR2 = tregister($0500000a);
NR_DR3 = tregister($0500000b);
NR_DR6 = tregister($0500000e);
NR_DR7 = tregister($0500000f);
NR_CR0 = tregister($05000010);
NR_CR2 = tregister($05000012);
NR_CR3 = tregister($05000013);
NR_CR4 = tregister($05000014);
NR_TR3 = tregister($0500001b);
NR_TR4 = tregister($0500001c);
NR_TR5 = tregister($0500001d);
NR_TR6 = tregister($0500001e);
NR_TR7 = tregister($0500001f);
NR_ST0 = tregister($02000000);
NR_ST1 = tregister($02000001);
NR_ST2 = tregister($02000002);
NR_ST3 = tregister($02000003);
NR_ST4 = tregister($02000004);
NR_ST5 = tregister($02000005);
NR_ST6 = tregister($02000006);
NR_ST7 = tregister($02000007);
NR_ST = tregister($02000008);
NR_MM0 = tregister($03000000);
NR_MM1 = tregister($03000001);
NR_MM2 = tregister($03000002);
NR_MM3 = tregister($03000003);
NR_MM4 = tregister($03000004);
NR_MM5 = tregister($03000005);
NR_MM6 = tregister($03000006);
NR_MM7 = tregister($03000007);
NR_XMM0 = tregister($040C0000);
NR_XMM1 = tregister($040C0001);
NR_XMM2 = tregister($040C0002);
NR_XMM3 = tregister($040C0003);
NR_XMM4 = tregister($040C0004);
NR_XMM5 = tregister($040C0005);
NR_XMM6 = tregister($040C0006);
NR_XMM7 = tregister($040C0007);
NR_XMM8 = tregister($040C0008);
NR_XMM9 = tregister($040C0009);
NR_XMM10 = tregister($040C000a);
NR_XMM11 = tregister($040C000b);
NR_XMM12 = tregister($040C000c);
NR_XMM13 = tregister($040C000d);
NR_XMM14 = tregister($040C000e);
NR_XMM15 = tregister($040C000f);
NR_XMM16 = tregister($040C0010);
NR_XMM17 = tregister($040C0011);
NR_XMM18 = tregister($040C0012);
NR_XMM19 = tregister($040C0013);
NR_XMM20 = tregister($040C0014);
NR_XMM21 = tregister($040C0015);
NR_XMM22 = tregister($040C0016);
NR_XMM23 = tregister($040C0017);
NR_XMM24 = tregister($040C0018);
NR_XMM25 = tregister($040C0019);
NR_XMM26 = tregister($040C001A);
NR_XMM27 = tregister($040C001B);
NR_XMM28 = tregister($040C001C);
NR_XMM29 = tregister($040C001D);
NR_XMM30 = tregister($040C001E);
NR_XMM31 = tregister($040C001F);
NR_YMM0 = tregister($040D0000);
NR_YMM1 = tregister($040D0001);
NR_YMM2 = tregister($040D0002);
NR_YMM3 = tregister($040D0003);
NR_YMM4 = tregister($040D0004);
NR_YMM5 = tregister($040D0005);
NR_YMM6 = tregister($040D0006);
NR_YMM7 = tregister($040D0007);
NR_YMM8 = tregister($040D0008);
NR_YMM9 = tregister($040D0009);
NR_YMM10 = tregister($040D000a);
NR_YMM11 = tregister($040D000b);
NR_YMM12 = tregister($040D000c);
NR_YMM13 = tregister($040D000d);
NR_YMM14 = tregister($040D000e);
NR_YMM15 = tregister($040D000f);
NR_YMM16 = tregister($040D0010);
NR_YMM17 = tregister($040D0011);
NR_YMM18 = tregister($040D0012);
NR_YMM19 = tregister($040D0013);
NR_YMM20 = tregister($040D0014);
NR_YMM21 = tregister($040D0015);
NR_YMM22 = tregister($040D0016);
NR_YMM23 = tregister($040D0017);
NR_YMM24 = tregister($040D0018);
NR_YMM25 = tregister($040D0019);
NR_YMM26 = tregister($040D001a);
NR_YMM27 = tregister($040D001b);
NR_YMM28 = tregister($040D001c);
NR_YMM29 = tregister($040D001d);
NR_YMM30 = tregister($040D001e);
NR_YMM31 = tregister($040D001f);
NR_ZMM0 = tregister($040E0000);
NR_ZMM1 = tregister($040E0001);
NR_ZMM2 = tregister($040E0002);
NR_ZMM3 = tregister($040E0003);
NR_ZMM4 = tregister($040E0004);
NR_ZMM5 = tregister($040E0005);
NR_ZMM6 = tregister($040E0006);
NR_ZMM7 = tregister($040E0007);
NR_ZMM8 = tregister($040E0008);
NR_ZMM9 = tregister($040E0009);
NR_ZMM10 = tregister($040E000A);
NR_ZMM11 = tregister($040E000B);
NR_ZMM12 = tregister($040E000C);
NR_ZMM13 = tregister($040E000D);
NR_ZMM14 = tregister($040E000E);
NR_ZMM15 = tregister($040E000F);
NR_ZMM16 = tregister($040E0010);
NR_ZMM17 = tregister($040E0011);
NR_ZMM18 = tregister($040E0012);
NR_ZMM19 = tregister($040E0013);
NR_ZMM20 = tregister($040E0014);
NR_ZMM21 = tregister($040E0015);
NR_ZMM22 = tregister($040E0016);
NR_ZMM23 = tregister($040E0017);
NR_ZMM24 = tregister($040E0018);
NR_ZMM25 = tregister($040E0019);
NR_ZMM26 = tregister($040E001A);
NR_ZMM27 = tregister($040E001B);
NR_ZMM28 = tregister($040E001C);
NR_ZMM29 = tregister($040E001D);
NR_ZMM30 = tregister($040E001E);
NR_ZMM31 = tregister($040E001F);
NR_K0 = tregister($06000000);
NR_K1 = tregister($06000001);
NR_K2 = tregister($06000002);
NR_K3 = tregister($06000003);
NR_K4 = tregister($06000004);
NR_K5 = tregister($06000005);
NR_K6 = tregister($06000006);
NR_K7 = tregister($06000007);

    type
      { Number of registers used for indexing in tables }
      tregisterindex=0..223;

    const
      regnumber_table : array[tregisterindex] of tregister = (
tregister($00000000),
tregister($01010000),
tregister($01020000),
tregister($01030000),
tregister($01040000),
tregister($01050000),
tregister($01010001),
tregister($01020001),
tregister($01030001),
tregister($01040001),
tregister($01050001),
tregister($01010002),
tregister($01020002),
tregister($01030002),
tregister($01040002),
tregister($01050002),
tregister($01010003),
tregister($01020003),
tregister($01030003),
tregister($01040003),
tregister($01050003),
tregister($01010004),
tregister($01030004),
tregister($01040004),
tregister($01050004),
tregister($01010005),
tregister($01030005),
tregister($01040005),
tregister($01050005),
tregister($01010006),
tregister($01030006),
tregister($01040006),
tregister($01050006),
tregister($01010007),
tregister($01030007),
tregister($01040007),
tregister($01050007),
tregister($01050008),
tregister($01010008),
tregister($01030008),
tregister($01040008),
tregister($01050009),
tregister($01010009),
tregister($01030009),
tregister($01040009),
tregister($0105000a),
tregister($0101000a),
tregister($0103000a),
tregister($0104000a),
tregister($0105000b),
tregister($0101000b),
tregister($0103000b),
tregister($0104000b),
tregister($0105000c),
tregister($0101000c),
tregister($0103000c),
tregister($0104000c),
tregister($0105000d),
tregister($0101000d),
tregister($0103000d),
tregister($0104000d),
tregister($0105000e),
tregister($0101000e),
tregister($0103000e),
tregister($0104000e),
tregister($0105000f),
tregister($0101000f),
tregister($0103000f),
tregister($0104000f),
tregister($05000000),
tregister($05000001),
tregister($05000002),
tregister($05000003),
tregister($05000004),
tregister($05000005),
tregister($05030006),
tregister($05040006),
tregister($05050006),
tregister($050f0006),
tregister($05100006),
tregister($05110006),
tregister($05120006),
tregister($05130006),
tregister($05140006),
tregister($05150006),
tregister($05160006),
tregister($05050007),
tregister($05040007),
tregister($05000008),
tregister($05000009),
tregister($0500000a),
tregister($0500000b),
tregister($0500000e),
tregister($0500000f),
tregister($05000010),
tregister($05000012),
tregister($05000013),
tregister($05000014),
tregister($0500001b),
tregister($0500001c),
tregister($0500001d),
tregister($0500001e),
tregister($0500001f),
tregister($02000000),
tregister($02000001),
tregister($02000002),
tregister($02000003),
tregister($02000004),
tregister($02000005),
tregister($02000006),
tregister($02000007),
tregister($02000008),
tregister($03000000),
tregister($03000001),
tregister($03000002),
tregister($03000003),
tregister($03000004),
tregister($03000005),
tregister($03000006),
tregister($03000007),
tregister($040C0000),
tregister($040C0001),
tregister($040C0002),
tregister($040C0003),
tregister($040C0004),
tregister($040C0005),
tregister($040C0006),
tregister($040C0007),
tregister($040C0008),
tregister($040C0009),
tregister($040C000a),
tregister($040C000b),
tregister($040C000c),
tregister($040C000d),
tregister($040C000e),
tregister($040C000f),
tregister($040C0010),
tregister($040C0011),
tregister($040C0012),
tregister($040C0013),
tregister($040C0014),
tregister($040C0015),
tregister($040C0016),
tregister($040C0017),
tregister($040C0018),
tregister($040C0019),
tregister($040C001A),
tregister($040C001B),
tregister($040C001C),
tregister($040C001D),
tregister($040C001E),
tregister($040C001F),
tregister($040D0000),
tregister($040D0001),
tregister($040D0002),
tregister($040D0003),
tregister($040D0004),
tregister($040D0005),
tregister($040D0006),
tregister($040D0007),
tregister($040D0008),
tregister($040D0009),
tregister($040D000a),
tregister($040D000b),
tregister($040D000c),
tregister($040D000d),
tregister($040D000e),
tregister($040D000f),
tregister($040D0010),
tregister($040D0011),
tregister($040D0012),
tregister($040D0013),
tregister($040D0014),
tregister($040D0015),
tregister($040D0016),
tregister($040D0017),
tregister($040D0018),
tregister($040D0019),
tregister($040D001a),
tregister($040D001b),
tregister($040D001c),
tregister($040D001d),
tregister($040D001e),
tregister($040D001f),
tregister($040E0000),
tregister($040E0001),
tregister($040E0002),
tregister($040E0003),
tregister($040E0004),
tregister($040E0005),
tregister($040E0006),
tregister($040E0007),
tregister($040E0008),
tregister($040E0009),
tregister($040E000A),
tregister($040E000B),
tregister($040E000C),
tregister($040E000D),
tregister($040E000E),
tregister($040E000F),
tregister($040E0010),
tregister($040E0011),
tregister($040E0012),
tregister($040E0013),
tregister($040E0014),
tregister($040E0015),
tregister($040E0016),
tregister($040E0017),
tregister($040E0018),
tregister($040E0019),
tregister($040E001A),
tregister($040E001B),
tregister($040E001C),
tregister($040E001D),
tregister($040E001E),
tregister($040E001F),
tregister($06000000),
tregister($06000001),
tregister($06000002),
tregister($06000003),
tregister($06000004),
tregister($06000005),
tregister($06000006),
tregister($06000007)

      );

      RS_DEFAULTFLAGS = RS_RFLAGS;
      NR_DEFAULTFLAGS = NR_RFLAGS;

{*****************************************************************************
                                Conditions
*****************************************************************************}

    type
      TAsmCond=(C_None,
        C_A,C_AE,C_B,C_BE,C_C,C_E,C_G,C_GE,C_L,C_LE,C_NA,C_NAE,
        C_NB,C_NBE,C_NC,C_NE,C_NG,C_NGE,C_NL,C_NLE,C_NO,C_NP,
        C_NS,C_NZ,C_O,C_P,C_PE,C_PO,C_S,C_Z
      );

    const
      cond2str:array[TAsmCond] of string[3]=('',
        'a','ae','b','be','c','e','g','ge','l','le','na','nae',
        'nb','nbe','nc','ne','ng','nge','nl','nle','no','np',
        'ns','nz','o','p','pe','po','s','z'
      );

{*****************************************************************************
                                   Flags
*****************************************************************************}

    type
      TResFlags = (F_E,F_NE,F_G,F_L,F_GE,F_LE,F_C,F_NC,
                   F_A,F_AE,F_B,F_BE,
                   F_S,F_NS,F_O,F_NO,
                   { For IEEE-compliant floating-point compares,
                     same as normal counterparts but additionally check PF }
                   F_FE,F_FNE,F_FA,F_FAE,F_FB,F_FBE);

    const
      FPUFlags = [F_FE,F_FNE,F_FA,F_FAE,F_FB,F_FBE];
      FPUFlags2Flags: array[F_FE..F_FBE] of TResFlags = (
        F_E,F_NE,F_A,F_AE,F_B,F_BE
      );

{*****************************************************************************
                                 Constants
*****************************************************************************}

    const
      { declare aliases }
      LOC_SSEREGISTER = LOC_MMREGISTER;
      LOC_CSSEREGISTER = LOC_CMMREGISTER;

      max_operands = 4;
      maxfpuregs = 8;

{*****************************************************************************
                            CPU Dependent Constants
*****************************************************************************}
///////////////////////////////
type
  topsize = (S_NO,
    S_B,S_W,S_L,S_Q,S_BW,S_BL,S_WL,S_BQ,S_WQ,S_LQ,
    S_IS,S_IL,S_IQ,
    S_FS,S_FL,S_FX,S_FV,S_FXX,
    S_MD,
    S_NEAR,S_FAR,S_SHORT,
    S_T,
    S_XMM,
    S_YMM,
    S_ZMM
  );

  TOpSizes = set of topsize;

const
  std_op2str:op2strtable=
(
'NONE',
'ADC',
'ADD',
'AND',
'BSF',
'BSR',
'BSWAP',
'BT',
'BTC',
'BTR',
'BTS',
'CALL',
'CBW',
'CDQ',
'CLC',
'CLD',
'CLI',
'CLTS',
'CMC',
'CMP',
'CMPSB',
'CMPSD',
'CMPSW',
'CMPXCHG',
'CMPXCHG486',
'CMPXCHG8B',
'CPUID',
'CWD',
'CWDE',
'DEC',
'DIV',
'EMMS',
'ENTER',
'F2XM1',
'FABS',
'FADD',
'FADDP',
'FBLD',
'FBSTP',
'FCHS',
'FCLEX',
'FCMOVB',
'FCMOVBE',
'FCMOVE',
'FCMOVNB',
'FCMOVNBE',
'FCMOVNE',
'FCMOVNU',
'FCMOVU',
'FCOM',
'FCOMI',
'FCOMIP',
'FCOMP',
'FCOMPP',
'FCOS',
'FDECSTP',
'FDISI',
'FDIV',
'FDIVP',
'FDIVR',
'FDIVRP',
'FEMMS',
'FENI',
'FFREE',
'FIADD',
'FICOM',
'FICOMP',
'FIDIV',
'FIDIVR',
'FILD',
'FIMUL',
'FINCSTP',
'FINIT',
'FIST',
'FISTP',
'FISTTP',
'FISUB',
'FISUBR',
'FLD',
'FLD1',
'FLDCW',
'FLDENV',
'FLDL2E',
'FLDL2T',
'FLDLG2',
'FLDLN2',
'FLDPI',
'FLDZ',
'FMUL',
'FMULP',
'FNCLEX',
'FNDISI',
'FNENI',
'FNINIT',
'FNOP',
'FNSAVE',
'FNSTCW',
'FNSTENV',
'FNSTSW',
'FPATAN',
'FPREM',
'FPREM1',
'FPTAN',
'FRNDINT',
'FRSTOR',
'FSAVE',
'FSCALE',
'FSETPM',
'FSIN',
'FSINCOS',
'FSQRT',
'FST',
'FSTCW',
'FSTENV',
'FSTP',
'FSTSW',
'FSUB',
'FSUBP',
'FSUBR',
'FSUBRP',
'FTST',
'FUCOM',
'FUCOMI',
'FUCOMIP',
'FUCOMP',
'FUCOMPP',
'FWAIT',
'FXAM',
'FXCH',
'FXTRACT',
'FYL2X',
'FYL2XP1',
'HLT',
'IBTS',
'ICEBP',
'IDIV',
'IMUL',
'IN',
'INC',
'INSB',
'INSD',
'INSW',
'INT',
'INT01',
'INT1',
'INT03',
'INT3',
'INVD',
'INVLPG',
'IRET',
'IRETD',
'IRETW',
'IRETQ',
'JECXZ',
'JRCXZ',
'JMP',
'LAHF',
'LAR',
'LCALL',
'LEA',
'LEAVE',
'LFS',
'LGDT',
'LGS',
'LIDT',
'LJMP',
'LLDT',
'LMSW',
'LOADALL',
'LOADALL286',
'LOCK',
'LODSB',
'LODSD',
'LODSW',
'LOOP',
'LOOPE',
'LOOPNE',
'LOOPNZ',
'LOOPZ',
'LSL',
'LSS',
'LTR',
'MONITOR',
'MOV',
'MOVD',
'MOVQ',
'MOVSB',
'MOVSD',
'MOVSQ',
'MOVSW',
'MOVSX',
'MOVZX',
'MUL',
'MWAIT',
'NEG',
'NOP',
'NOT',
'OR',
'OUT',
'OUTSB',
'OUTSD',
'OUTSW',
'PACKSSDW',
'PACKSSWB',
'PACKUSWB',
'PADDB',
'PADDD',
'PADDSB',
'PADDSIW',
'PADDSW',
'PADDUSB',
'PADDUSW',
'PADDW',
'PAND',
'PANDN',
'PAVEB',
'PAVGUSB',
'PCMPEQB',
'PCMPEQD',
'PCMPEQW',
'PCMPGTB',
'PCMPGTD',
'PCMPGTW',
'PDISTIB',
'PF2ID',
'PFACC',
'PFADD',
'PFCMPEQ',
'PFCMPGE',
'PFCMPGT',
'PFMAX',
'PFMIN',
'PFMUL',
'PFRCP',
'PFRCPIT1',
'PFRCPIT2',
'PFRSQIT1',
'PFRSQRT',
'PFSUB',
'PFSUBR',
'PI2FD',
'PMACHRIW',
'PMADDWD',
'PMAGW',
'PMULHRIW',
'PMULHRWA',
'PMULHRWC',
'PMULHW',
'PMULLW',
'PMVGEZB',
'PMVLZB',
'PMVNZB',
'PMVZB',
'POP',
'POPF',
'POPFW',
'POPFQ',
'POR',
'PREFETCH',
'PREFETCHW',
'PSLLD',
'PSLLDQ',
'PSLLQ',
'PSLLW',
'PSRAD',
'PSRAW',
'PSRLD',
'PSRLQ',
'PSRLW',
'PSUBB',
'PSUBD',
'PSUBSB',
'PSUBSIW',
'PSUBSW',
'PSUBUSB',
'PSUBUSW',
'PSUBW',
'PUNPCKHBW',
'PUNPCKHDQ',
'PUNPCKHWD',
'PUNPCKLBW',
'PUNPCKLDQ',
'PUNPCKLWD',
'PUSH',
'PUSHF',
'PUSHFW',
'PUSHFQ',
'PXOR',
'RCL',
'RCR',
'RDSHR',
'RDMSR',
'RDPMC',
'RDTSC',
'REP',
'REPE',
'REPNE',
'REPNZ',
'REPZ',
'RET',
'RETF',
'RETN',
'RETW',
'RETFW',
'RETNW',
'RETFD',
'RETQ',
'RETFQ',
'RETNQ',
'ROL',
'ROR',
'RSDC',
'RSLDT',
'RSM',
'SAHF',
'SAL',
'SAR',
'SBB',
'SCASB',
'SCASD',
'SCASQ',
'SCASW',
'SEGCS',
'SEGDS',
'SEGES',
'SEGFS',
'SEGGS',
'SEGSS',
'SGDT',
'SHL',
'SHLD',
'SHR',
'SHRD',
'SIDT',
'SLDT',
'SMI',
'SMINT',
'SMINTOLD',
'SMSW',
'STC',
'STD',
'STI',
'STOSB',
'STOSD',
'STOSW',
'STR',
'SUB',
'SVDC',
'SVLDT',
'SVTS',
'SYSCALL',
'SYSENTER',
'SYSEXIT',
'SYSRET',
'TEST',
'UD1',
'UD2',
'UMOV',
'VERR',
'VERW',
'WAIT',
'WBINVD',
'WRSHR',
'WRMSR',
'XADD',
'XBTS',
'XCHG',
'XLAT',
'XLATB',
'XOR',
'XSTORE',
'XCRYPTECB',
'XCRYPTCBC',
'XCRYPTCFB',
'XCRYPTOFB',
'CMOV',
'J',
'SET',
'MOVS',
'CMPS',
'SCAS',
'LODS',
'STOS',
'INS',
'OUTS',
'ADDPS',
'ADDSS',
'ANDNPS',
'ANDPS',
'CMPEQPS',
'CMPEQSS',
'CMPLEPS',
'CMPLESS',
'CMPLTPS',
'CMPLTSS',
'CMPNEQPS',
'CMPNEQSS',
'CMPNLEPS',
'CMPNLESS',
'CMPNLTPS',
'CMPNLTSS',
'CMPORDPS',
'CMPORDSS',
'CMPUNORDPS',
'CMPUNORDSS',
'CMPPS',
'CMPSS',
'COMISS',
'CVTPI2PS',
'CVTPS2PI',
'CVTSI2SS',
'CVTSS2SI',
'CVTTPS2PI',
'CVTTSS2SI',
'DIVPS',
'DIVSS',
'LDMXCSR',
'MAXPS',
'MAXSS',
'MINPS',
'MINSS',
'MOVAPS',
'MOVHPS',
'MOVLHPS',
'MOVLPS',
'MOVHLPS',
'MOVMSKPS',
'MOVNTPS',
'MOVSS',
'MOVUPS',
'MULPS',
'MULSS',
'ORPS',
'RCPPS',
'RCPSS',
'RSQRTPS',
'RSQRTSS',
'SHUFPS',
'SQRTPS',
'SQRTSS',
'STMXCSR',
'SUBPS',
'SUBSS',
'UCOMISS',
'UNPCKHPS',
'UNPCKLPS',
'XORPS',
'FXRSTOR',
'FXSAVE',
'PREFETCHNTA',
'PREFETCHT0',
'PREFETCHT1',
'PREFETCHT2',
'SFENCE',
'MASKMOVQ',
'MOVNTQ',
'PAVGB',
'PAVGW',
'PEXTRW',
'PINSRW',
'PMAXSW',
'PMAXUB',
'PMINSW',
'PMINUB',
'PMOVMSKB',
'PMULHUW',
'PSADBW',
'PSHUFW',
'PFNACC',
'PFPNACC',
'PI2FW',
'PF2IW',
'PSWAPD',
'FFREEP',
'MASKMOVDQU',
'CLFLUSH',
'MOVNTDQ',
'MOVNTI',
'MOVNTPD',
'PAUSE',
'LFENCE',
'MFENCE',
'MOVDQA',
'MOVDQU',
'MOVDQ2Q',
'MOVQ2DQ',
'PADDQ',
'PMULUDQ',
'PSHUFD',
'PSHUFHW',
'PSHUFLW',
'PSRLDQ',
'PSUBQ',
'PUNPCKHQDQ',
'PUNPCKLQDQ',
'ADDPD',
'ADDSD',
'ANDNPD',
'ANDPD',
'CMPEQPD',
'CMPEQSD',
'CMPLEPD',
'CMPLESD',
'CMPLTPD',
'CMPLTSD',
'CMPNEQPD',
'CMPNEQSD',
'CMPNLEPD',
'CMPNLESD',
'CMPNLTPD',
'CMPNLTSD',
'CMPORDPD',
'CMPORDSD',
'CMPUNORDPD',
'CMPUNORDSD',
'CMPPD',
'COMISD',
'CVTDQ2PD',
'CVTDQ2PS',
'CVTPD2DQ',
'CVTPD2PI',
'CVTPD2PS',
'CVTPI2PD',
'CVTPS2DQ',
'CVTPS2PD',
'CVTSD2SI',
'CVTSD2SS',
'CVTSI2SD',
'CVTSS2SD',
'CVTTPD2PI',
'CVTTPD2DQ',
'CVTTPS2DQ',
'CVTTSD2SI',
'DIVPD',
'DIVSD',
'MAXPD',
'MAXSD',
'MINPD',
'MINSD',
'MOVAPD',
'MOVHPD',
'MOVLPD',
'MOVMSKPD',
'MOVUPD',
'MULPD',
'MULSD',
'ORPD',
'SHUFPD',
'SQRTPD',
'SQRTSD',
'SUBPD',
'SUBSD',
'UCOMISD',
'UNPCKHPD',
'UNPCKLPD',
'XORPD',
'ADDSUBPD',
'ADDSUBPS',
'HADDPD',
'HADDPS',
'HSUBPD',
'HSUBPS',
'LDDQU',
'MOVDDUP',
'MOVSHDUP',
'MOVSLDUP',
'VMREAD',
'VMWRITE',
'VMCALL',
'VMLAUNCH',
'VMRESUME',
'VMXOFF',
'VMXON',
'VMCLEAR',
'VMPTRLD',
'VMPTRST',
'VMRUN',
'VMMCALL',
'VMLOAD',
'VMSAVE',
'STGI',
'CLGI',
'SKINIT',
'INVLPGA',
'MONTMUL',
'XSHA1',
'XSHA256',
'DMINT',
'RDM',
'MOVABS',
'MOVSXD',
'CQO',
'CDQE',
'CMPXCHG16B',
'MOVNTSS',
'MOVNTSD',
'INSERTQ',
'EXTRQ',
'LZCNT',
'PABSB',
'PABSW',
'PABSD',
'PALIGNR',
'PHADDW',
'PHADDD',
'PHADDSW',
'PHSUBW',
'PHSUBD',
'PHSUBSW',
'PMADDUBSW',
'PMULHRSW',
'PSHUFB',
'PSIGNB',
'PSIGNW',
'PSIGND',
'BLENDPS',
'BLENDPD',
'BLENDVPS',
'BLENDVPD',
'DPPS',
'DPPD',
'EXTRACTPS',
'INSERTPS',
'MOVNTDQA',
'MPSADBW',
'PACKUSDW',
'PBLENDVB',
'PBLENDW',
'PCMPEQQ',
'PEXTRB',
'PEXTRD',
'PEXTRQ',
'PHMINPOSUW',
'PINSRB',
'PINSRD',
'PINSRQ',
'PMAXSB',
'PMAXSD',
'PMAXUD',
'PMAXUW',
'PMINSB',
'PMINSD',
'PMINUW',
'PMINUD',
'PMOVSXBW',
'PMOVSXBD',
'PMOVSXBQ',
'PMOVSXWD',
'PMOVSXWQ',
'PMOVSXDQ',
'PMOVZXBW',
'PMOVZXBD',
'PMOVZXBQ',
'PMOVZXWD',
'PMOVZXWQ',
'PMOVZXDQ',
'PMULDQ',
'PMULLD',
'PTEST',
'ROUNDPS',
'ROUNDPD',
'ROUNDSS',
'ROUNDSD',
'CRC32',
'PCMPESTRI',
'PCMPESTRM',
'PCMPISTRI',
'PCMPISTRM',
'PCMPGTQ',
'POPCNT',
'AESENC',
'AESENCLAST',
'AESDEC',
'AESDECLAST',
'AESIMC',
'AESKEYGENASSIST',
'RDTSCP',
'STOSQ',
'LODSQ',
'CMPSQ',
'MOVBE',
'PCLMULQDQ',
'VADDPD',
'VADDPS',
'VADDSD',
'VADDSS',
'VADDSUBPD',
'VADDSUBPS',
'VAESDEC',
'VAESDECLAST',
'VAESENC',
'VAESENCLAST',
'VAESIMC',
'VAESKEYGENASSIST',
'VANDNPD',
'VANDNPS',
'VANDPD',
'VANDPS',
'VBLENDPD',
'VBLENDPS',
'VBLENDVPD',
'VBLENDVPS',
'VBROADCASTF128',
'VBROADCASTSD',
'VBROADCASTSS',
'VCMPEQPS',
'VCMPLTPS',
'VCMPLEPS',
'VCMPUNORDPS',
'VCMPNEQPS',
'VCMPNLTPS',
'VCMPNLEPS',
'VCMPORDPS',
'VCMPEQ_UQPS',
'VCMPNGEPS',
'VCMPNGTPS',
'VCMPFALSEPS',
'VCMPNEQ_OQPS',
'VCMPGEPS',
'VCMPGTPS',
'VCMPTRUEPS',
'VCMPEQ_OSPS',
'VCMPLT_OQPS',
'VCMPLE_OQPS',
'VCMPUNORD_SPS',
'VCMPNEQ_USPS',
'VCMPNLT_UQPS',
'VCMPNLE_UQPS',
'VCMPORD_SPS',
'VCMPEQ_USPS',
'VCMPNGE_UQPS',
'VCMPNGT_UQPS',
'VCMPFALSE_OSPS',
'VCMPNEQ_OSPS',
'VCMPGE_OQPS',
'VCMPGT_OQPS',
'VCMPTRUE_USPS',
'VCMPEQPD',
'VCMPLTPD',
'VCMPLEPD',
'VCMPUNORDPD',
'VCMPNEQPD',
'VCMPNLTPD',
'VCMPNLEPD',
'VCMPORDPD',
'VCMPEQ_UQPD',
'VCMPNGEPD',
'VCMPNGTPD',
'VCMPFALSEPD',
'VCMPNEQ_OQPD',
'VCMPGEPD',
'VCMPGTPD',
'VCMPTRUEPD',
'VCMPEQ_OSPD',
'VCMPLT_OQPD',
'VCMPLE_OQPD',
'VCMPUNORD_SPD',
'VCMPNEQ_USPD',
'VCMPNLT_UQPD',
'VCMPNLE_UQPD',
'VCMPORD_SPD',
'VCMPEQ_USPD',
'VCMPNGE_UQPD',
'VCMPNGT_UQPD',
'VCMPFALSE_OSPD',
'VCMPNEQ_OSPD',
'VCMPGE_OQPD',
'VCMPGT_OQPD',
'VCMPTRUE_USPD',
'VCMPPD',
'VCMPPS',
'VCMPSD',
'VCMPSS',
'VCOMISD',
'VCOMISS',
'VCVTDQ2PD',
'VCVTDQ2PS',
'VCVTPD2DQ',
'VCVTPD2PS',
'VCVTPH2PS',
'VCVTPS2DQ',
'VCVTPS2PD',
'VCVTPS2PH',
'VCVTSD2SI',
'VCVTSD2SS',
'VCVTSI2SD',
'VCVTSI2SS',
'VCVTSS2SD',
'VCVTSS2SI',
'VCVTTPD2DQ',
'VCVTTPS2DQ',
'VCVTTSD2SI',
'VCVTTSS2SI',
'VDIVPD',
'VDIVPS',
'VDIVSD',
'VDIVSS',
'VDPPD',
'VDPPS',
'VEXTRACTF128',
'VEXTRACTPS',
'VHADDPD',
'VHADDPS',
'VHSUBPD',
'VHSUBPS',
'VINSERTF128',
'VINSERTPS',
'VLDDQU',
'VLDMXCSR',
'VMASKMOVDQU',
'VMASKMOVPD',
'VMASKMOVPS',
'VMAXPD',
'VMAXPS',
'VMAXSD',
'VMAXSS',
'VMINPD',
'VMINPS',
'VMINSD',
'VMINSS',
'VMOVAPD',
'VMOVAPS',
'VMOVD',
'VMOVDDUP',
'VMOVDQA',
'VMOVDQU',
'VMOVHLPS',
'VMOVHPD',
'VMOVHPS',
'VMOVLHPS',
'VMOVLPD',
'VMOVLPS',
'VMOVMSKPD',
'VMOVMSKPS',
'VMOVNTDQ',
'VMOVNTDQA',
'VMOVNTPD',
'VMOVNTPS',
'VMOVQ',
'VMOVSD',
'VMOVSHDUP',
'VMOVSLDUP',
'VMOVSS',
'VMOVUPD',
'VMOVUPS',
'VMPSADBW',
'VMULPD',
'VMULPS',
'VMULSD',
'VMULSS',
'VORPD',
'VORPS',
'VPABSB',
'VPABSD',
'VPABSW',
'VPACKSSDW',
'VPACKSSWB',
'VPACKUSDW',
'VPACKUSWB',
'VPADDB',
'VPADDD',
'VPADDQ',
'VPADDSB',
'VPADDSW',
'VPADDUSB',
'VPADDUSW',
'VPADDW',
'VPALIGNR',
'VPAND',
'VPANDN',
'VPAVGB',
'VPAVGW',
'VPBLENDVB',
'VPBLENDW',
'VPCLMULQDQ',
'VPCMPEQB',
'VPCMPEQD',
'VPCMPEQQ',
'VPCMPEQW',
'VPCMPESTRI',
'VPCMPESTRM',
'VPCMPGTB',
'VPCMPGTD',
'VPCMPGTQ',
'VPCMPGTW',
'VPCMPISTRI',
'VPCMPISTRM',
'VPERM2F128',
'VPERMILPD',
'VPERMILPS',
'VPEXTRB',
'VPEXTRD',
'VPEXTRQ',
'VPEXTRW',
'VPHADDD',
'VPHADDSW',
'VPHADDW',
'VPHMINPOSUW',
'VPHSUBD',
'VPHSUBSW',
'VPHSUBW',
'VPINSRB',
'VPINSRD',
'VPINSRQ',
'VPINSRW',
'VPMADDUBSW',
'VPMADDWD',
'VPMAXSB',
'VPMAXSD',
'VPMAXSW',
'VPMAXUB',
'VPMAXUD',
'VPMAXUW',
'VPMINSB',
'VPMINSD',
'VPMINSW',
'VPMINUB',
'VPMINUD',
'VPMINUW',
'VPMOVMSKB',
'VPMOVSXBD',
'VPMOVSXBQ',
'VPMOVSXBW',
'VPMOVSXDQ',
'VPMOVSXWD',
'VPMOVSXWQ',
'VPMOVZXBD',
'VPMOVZXBQ',
'VPMOVZXBW',
'VPMOVZXDQ',
'VPMOVZXWD',
'VPMOVZXWQ',
'VPMULDQ',
'VPMULHRSW',
'VPMULHUW',
'VPMULHW',
'VPMULLD',
'VPMULLW',
'VPMULUDQ',
'VPOR',
'VPSADBW',
'VPSHUFB',
'VPSHUFD',
'VPSHUFHW',
'VPSHUFLW',
'VPSIGNB',
'VPSIGND',
'VPSIGNW',
'VPSLLD',
'VPSLLDQ',
'VPSLLQ',
'VPSLLW',
'VPSRAD',
'VPSRAW',
'VPSRLD',
'VPSRLDQ',
'VPSRLQ',
'VPSRLW',
'VPSUBB',
'VPSUBD',
'VPSUBQ',
'VPSUBSB',
'VPSUBSW',
'VPSUBUSB',
'VPSUBUSW',
'VPSUBW',
'VPTEST',
'VPUNPCKHBW',
'VPUNPCKHDQ',
'VPUNPCKHQDQ',
'VPUNPCKHWD',
'VPUNPCKLBW',
'VPUNPCKLDQ',
'VPUNPCKLQDQ',
'VPUNPCKLWD',
'VPXOR',
'VRCPPS',
'VRCPSS',
'VROUNDPD',
'VROUNDPS',
'VROUNDSD',
'VROUNDSS',
'VRSQRTPS',
'VRSQRTSS',
'VSHUFPD',
'VSHUFPS',
'VSQRTPD',
'VSQRTPS',
'VSQRTSD',
'VSQRTSS',
'VSTMXCSR',
'VSUBPD',
'VSUBPS',
'VSUBSD',
'VSUBSS',
'VTESTPD',
'VTESTPS',
'VUCOMISD',
'VUCOMISS',
'VUNPCKHPD',
'VUNPCKHPS',
'VUNPCKLPD',
'VUNPCKLPS',
'VXORPD',
'VXORPS',
'VZEROALL',
'VZEROUPPER',
'ANDN',
'BEXTR',
'BLSI',
'BLSMSK',
'BLSR',
'TZCNT',
'BZHI',
'MULX',
'PDEP',
'PEXT',
'RORX',
'SARX',
'SHLX',
'SHRX',
'ADCX',
'ADOX',
'VBROADCASTI128',
'VEXTRACTI128',
'VINSERTI128',
'VPBLENDD',
'VPBROADCASTB',
'VPBROADCASTD',
'VPBROADCASTQ',
'VPBROADCASTW',
'VPERM2I128',
'VPERMD',
'VPERMPD',
'VPERMPS',
'VPERMQ',
'VPMASKMOVD',
'VPMASKMOVQ',
'VPSLLVD',
'VPSLLVQ',
'VPSRAVD',
'VPSRLVD',
'VPSRLVQ',
'VGATHERDPD',
'VGATHERDPS',
'VGATHERQPD',
'VGATHERQPS',
'VPGATHERDD',
'VPGATHERDQ',
'VPGATHERQD',
'VPGATHERQQ',
'VFMADDPD',
'VFMADD132PD',
'VFMADD132PS',
'VFMADD132SD',
'VFMADD132SS',
'VFMADD213PD',
'VFMADD213PS',
'VFMADD213SD',
'VFMADD213SS',
'VFMADD231PD',
'VFMADD231PS',
'VFMADD231SD',
'VFMADD231SS',
'VFMADDSUB132PD',
'VFMADDSUB132PS',
'VFMADDSUB213PD',
'VFMADDSUB213PS',
'VFMADDSUB231PD',
'VFMADDSUB231PS',
'VFMSUB132PD',
'VFMSUB132PS',
'VFMSUB132SD',
'VFMSUB132SS',
'VFMSUB213PD',
'VFMSUB213PS',
'VFMSUB213SD',
'VFMSUB213SS',
'VFMSUB231PD',
'VFMSUB231PS',
'VFMSUB231SD',
'VFMSUB231SS',
'VFMSUBADD132PD',
'VFMSUBADD132PS',
'VFMSUBADD213PD',
'VFMSUBADD213PS',
'VFMSUBADD231PD',
'VFMSUBADD231PS',
'VFNMADD132PD',
'VFNMADD132PS',
'VFNMADD132SD',
'VFNMADD132SS',
'VFNMADD213PD',
'VFNMADD213PS',
'VFNMADD213SD',
'VFNMADD213SS',
'VFNMADD231PD',
'VFNMADD231PS',
'VFNMADD231SD',
'VFNMADD231SS',
'VFNMSUB132PD',
'VFNMSUB132PS',
'VFNMSUB132SD',
'VFNMSUB132SS',
'VFNMSUB213PD',
'VFNMSUB213PS',
'VFNMSUB213SD',
'VFNMSUB213SS',
'VFNMSUB231PD',
'VFNMSUB231PS',
'VFNMSUB231SD',
'VFNMSUB231SS',
'XACQUIRE',
'XRELEASE',
'XBEGIN',
'XABORT',
'XEND',
'XTEST',
'RDRAND',
'RDSEED',
'XGETBV',
'XSETBV',
'XSAVE',
'XSAVE64',
'XRSTOR',
'XRSTOR64',
'XSAVEOPT',
'XSAVEOPT64',
'PREFETCHWT1',
'KADDB',
'KADDD',
'KADDQ',
'KADDW',
'KANDB',
'KANDD',
'KANDNB',
'KANDND',
'KANDNQ',
'KANDNW',
'KANDQ',
'KANDW',
'KMOVB',
'KMOVD',
'KMOVQ',
'KMOVW',
'KNOTB',
'KNOTD',
'KNOTQ',
'KNOTW',
'KORB',
'KORD',
'KORQ',
'KORTESTB',
'KORTESTD',
'KORTESTQ',
'KORTESTW',
'KORW',
'KSHIFTLB',
'KSHIFTLD',
'KSHIFTLQ',
'KSHIFTLW',
'KSHIFTRB',
'KSHIFTRD',
'KSHIFTRQ',
'KSHIFTRW',
'KTESTB',
'KTESTD',
'KTESTQ',
'KTESTW',
'KUNPCKBW',
'KUNPCKDQ',
'KUNPCKWD',
'KXNORB',
'KXNORD',
'KXNORQ',
'KXNORW',
'KXORB',
'KXORD',
'KXORQ',
'KXORW',
'VALIGND',
'VALIGNQ',
'VBLENDMPD',
'VBLENDMPS',
'VBROADCASTF32X2',
'VBROADCASTF32X4',
'VBROADCASTF32X8',
'VBROADCASTF64X2',
'VBROADCASTF64X4',
'VBROADCASTI32X2',
'VBROADCASTI32X4',
'VBROADCASTI32X8',
'VBROADCASTI64X2',
'VBROADCASTI64X4',
'VCOMPRESSPD',
'VCOMPRESSPS',
'VCVTPD2QQ',
'VCVTPD2UDQ',
'VCVTPD2UQQ',
'VCVTPS2QQ',
'VCVTPS2UDQ',
'VCVTPS2UQQ',
'VCVTQQ2PD',
'VCVTQQ2PS',
'VCVTSD2USI',
'VCVTSS2USI',
'VCVTTPD2QQ',
'VCVTTPD2UDQ',
'VCVTTPD2UQQ',
'VCVTTPS2QQ',
'VCVTTPS2UDQ',
'VCVTTPS2UQQ',
'VCVTTSD2USI',
'VCVTTSS2USI',
'VCVTUDQ2PD',
'VCVTUDQ2PS',
'VCVTUQQ2PD',
'VCVTUQQ2PS',
'VCVTUSI2SD',
'VCVTUSI2SS',
'VDBPSADBW',
'VEXP2PD',
'VEXP2PS',
'VEXPANDPD',
'VEXPANDPS',
'VEXTRACTF32X4',
'VEXTRACTF32X8',
'VEXTRACTF64X2',
'VEXTRACTF64X4',
'VEXTRACTI32X4',
'VEXTRACTI32X8',
'VEXTRACTI64X2',
'VEXTRACTI64X4',
'VFIXUPIMMPD',
'VFIXUPIMMPS',
'VFIXUPIMMSD',
'VFIXUPIMMSS',
'VFPCLASSPD',
'VFPCLASSPS',
'VFPCLASSSD',
'VFPCLASSSS',
'VGETEXPPD',
'VGETEXPPS',
'VGETEXPSD',
'VGETEXPSS',
'VGETMANTPD',
'VGETMANTPS',
'VGETMANTSD',
'VGETMANTSS',
'VINSERTF32X4',
'VINSERTF32X8',
'VINSERTF64X2',
'VINSERTF64X4',
'VINSERTI32X4',
'VINSERTI32X8',
'VINSERTI64X2',
'VINSERTI64X4',
'VMOVDQA32',
'VMOVDQA64',
'VMOVDQU16',
'VMOVDQU32',
'VMOVDQU64',
'VMOVDQU8',
'VPABSQ',
'VPANDD',
'VPANDND',
'VPANDNQ',
'VPANDQ',
'VPBLENDMB',
'VPBLENDMD',
'VPBLENDMQ',
'VPBLENDMW',
'VPCMPB',
'VPCMPD',
'VPCMPQ',
'VPCMPUB',
'VPCMPUD',
'VPCMPUQ',
'VPCMPUW',
'VPCMPW',
'VPCOMPRESSD',
'VPCOMPRESSQ',
'VPCONFLICTD',
'VPCONFLICTQ',
'VPERMB',
'VPERMI2B',
'VPERMI2D',
'VPERMI2PD',
'VPERMI2PS',
'VPERMI2Q',
'VPERMI2W',
'VPERMT2B',
'VPERMT2D',
'VPERMT2PD',
'VPERMT2PS',
'VPERMT2Q',
'VPERMT2W',
'VPERMW',
'VPEXPANDD',
'VPEXPANDQ',
'VPLZCNTD',
'VPLZCNTQ',
'VPMADD52HUQ',
'VPMADD52LUQ',
'VPMAXSQ',
'VPMAXUQ',
'VPMINSQ',
'VPMINUQ',
'VPMOVB2M',
'VPMOVD2M',
'VPMOVDB',
'VPMOVDW',
'VPMOVM2B',
'VPMOVM2D',
'VPMOVM2Q',
'VPMOVM2W',
'VPMOVQ2M',
'VPMOVQB',
'VPMOVQD',
'VPMOVQW',
'VPMOVSDB',
'VPMOVSDW',
'VPMOVSQB',
'VPMOVSQD',
'VPMOVSQW',
'VPMOVSWB',
'VPMOVUSDB',
'VPMOVUSDW',
'VPMOVUSQB',
'VPMOVUSQD',
'VPMOVUSQW',
'VPMOVUSWB',
'VPMOVW2M',
'VPMOVWB',
'VPMULLQ',
'VPMULTISHIFTQB',
'VPORD',
'VPORQ',
'VPROLD',
'VPROLQ',
'VPROLVD',
'VPROLVQ',
'VPRORD',
'VPRORQ',
'VPRORVD',
'VPRORVQ',
'VPSCATTERDD',
'VPSCATTERDQ',
'VPSCATTERQD',
'VPSCATTERQQ',
'VPSLLVW',
'VPSRAQ',
'VPSRAVQ',
'VPSRAVW',
'VPSRLVW',
'VPTERNLOGD',
'VPTERNLOGQ',
'VPTESTMB',
'VPTESTMD',
'VPTESTMQ',
'VPTESTMW',
'VPTESTNMB',
'VPTESTNMD',
'VPTESTNMQ',
'VPTESTNMW',
'VPXORD',
'VPXORQ',
'VRANGEPD',
'VRANGEPS',
'VRANGESD',
'VRANGESS',
'VRCP14PD',
'VRCP14PS',
'VRCP14SD',
'VRCP14SS',
'VRCP28PD',
'VRCP28PS',
'VRCP28SD',
'VRCP28SS',
'VREDUCEPD',
'VREDUCEPS',
'VREDUCESD',
'VREDUCESS',
'VRNDSCALEPD',
'VRNDSCALEPS',
'VRNDSCALESD',
'VRNDSCALESS',
'VRSQRT14PD',
'VRSQRT14PS',
'VRSQRT14SD',
'VRSQRT14SS',
'VRSQRT28PD',
'VRSQRT28PS',
'VRSQRT28SD',
'VRSQRT28SS',
'VSCALEFPD',
'VSCALEFPS',
'VSCALEFSD',
'VSCALEFSS',
'VSCATTERDPD',
'VSCATTERDPS',
'VSCATTERQPD',
'VSCATTERQPS',
'VSHUFF32X4',
'VSHUFF64X2',
'VSHUFI32X4',
'VSHUFI64X2',
'VPCOMPRESSB',
'VPCOMPRESSW',
'VPDPBUSD',
'VPDPBUSDS',
'VPDPWSSD',
'VPDPWSSDS',
'VPEXPANDB',
'VPEXPANDW',
'VPOPCNTB',
'VPOPCNTD',
'VPOPCNTQ',
'VPOPCNTW',
'VPSHLDD',
'VPSHLDQ',
'VPSHLDVD',
'VPSHLDVQ',
'VPSHLDVW',
'VPSHLDW',
'VPSHRDD',
'VPSHRDQ',
'VPSHRDVD',
'VPSHRDVQ',
'VPSHRDVW',
'VPSHRDW',
'VPSHUFBITQMB',
'SHA1RNDS4',
'SHA1NEXTE',
'SHA1MSG1',
'SHA1MSG2',
'SHA256RNDS2',
'SHA256MSG1',
'SHA256MSG2'
);

      stab_regindex : array[tregisterindex] of shortint = (
-1,
0,
0,
0,
0,
0,
2,
2,
2,
2,
2,
1,
1,
1,
1,
1,
3,
3,
3,
3,
3,
4,
4,
4,
4,
5,
5,
5,
5,
6,
6,
6,
6,
7,
7,
7,
7,
8,
8,
8,
8,
9,
9,
9,
9,
10,
10,
10,
10,
11,
11,
11,
11,
12,
12,
12,
12,
13,
13,
13,
13,
14,
14,
14,
14,
15,
15,
15,
15,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
16,
16,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
-1,
33,
34,
35,
36,
37,
38,
39,
40,
33,
41,
42,
43,
44,
45,
46,
47,
48,
17,
18,
19,
20,
21,
22,
23,
24,
25,
26,
27,
28,
29,
30,
31,
32,
67,
68,
69,
70,
71,
72,
73,
74,
75,
76,
77,
78,
79,
80,
81,
82,
17,
18,
19,
20,
21,
22,
23,
24,
25,
26,
27,
28,
29,
30,
31,
32,
67,
68,
69,
70,
71,
72,
73,
74,
75,
76,
77,
78,
79,
80,
81,
82,
17,
18,
19,
20,
21,
22,
23,
24,
25,
26,
27,
28,
29,
30,
31,
32,
67,
68,
69,
70,
71,
72,
73,
74,
75,
76,
77,
78,
79,
80,
81,
82,
118,
119,
120,
121,
122,
123,
124,
125
      );

      OS_ADDR = OS_64;
      OS_INT = OS_64;
      OS_SINT = OS_S64;
      OS_FLOAT = OS_F80;
      OS_VECTOR = OS_M128;

      RS_STACK_POINTER_REG = RS_RSP;
      NR_STACK_POINTER_REG = NR_RSP;
      RS_FRAME_POINTER_REG = RS_RBP;
      NR_FRAME_POINTER_REG = NR_RBP;
      NR_RETURN_ADDRESS_REG = NR_RIP;
      NR_PIC_OFFSET_REG = NR_RBX;
      NR_FUNCTION_RETURN_REG = NR_RAX;
      RS_FUNCTION_RETURN_REG = RS_RAX;
      NR_FUNCTION_RETURN_REG_HIGH = NR_RDX;
      RS_FUNCTION_RETURN_REG_HIGH = RS_RDX;
      NR_FUNCTION_RESULT_REG = NR_FUNCTION_RETURN_REG;
      RS_FUNCTION_RESULT_REG = RS_FUNCTION_RETURN_REG;
      NR_FUNCTION_RESULT_REG_HIGH = NR_FUNCTION_RETURN_REG_HIGH;
      RS_FUNCTION_RESULT_REG_HIGH = RS_FUNCTION_RETURN_REG_HIGH;
      NR_FPU_RESULT_REG = NR_ST;
      NR_MM_RESULT_REG = NR_XMM0;
      RS_MM_RESULT_REG = RS_XMM0;
      NR_MM_RESULT_REG_HIGH = NR_XMM1;
      RS_MM_RESULT_REG_HIGH = RS_XMM1;
      PARENT_FRAMEPOINTER_OFFSET = 16;

    const
      std_param_align = 8;
//////////////////////////////

const
  topsize2memsize: array[topsize] of integer =
    (0, 8,16,32,64,8,8,16,8,16,32,
     16,32,64,
     16,32,64,0,0,
     64,
     0,0,0,
     80,
     128,
     256,
     512
    );

{*****************************************************************************
                                  Helpers
*****************************************************************************}

    function cgsize2subreg(regtype: tregistertype; s:Tcgsize):Tsubregister;
    function reg2opsize(r:Tregister):topsize;
    function reg_cgsize(const reg: tregister): tcgsize;
    function is_calljmp(o:tasmop):boolean;
    function is_calljmpuncondret(o:tasmop):boolean; {$ifdef USEINLINE}inline;{$endif USEINLINE}
    procedure inverse_flags(var f: TResFlags);
    function flags_to_cond(const f: TResFlags) : TAsmCond;
    function is_segment_reg(r:tregister):boolean;
    function findreg_by_number(r:Tregister):tregisterindex;
    function std_regnum_search(const s:string):Tregister;
    function std_regname(r:Tregister):string;
    function eh_return_data_regno(nr: longint): longint;

    function inverse_cond(const c: TAsmCond): TAsmCond; {$ifdef USEINLINE}inline;{$endif USEINLINE}
    function conditions_equal(const c1, c2: TAsmCond): boolean; {$ifdef USEINLINE}inline;{$endif USEINLINE}

    { Checks if Subset is a subset of c (e.g. "less than" is a subset of "less than or equal" }
    function condition_in(const Subset, c: TAsmCond): Boolean;

    { checks whether two segment registers are normally equal in the current memory model }
    function segment_regs_equal(r1,r2:tregister):boolean;

    { checks whether the specified op is an x86 string instruction (e.g. cmpsb, movsd, scasw, etc.) }
    function is_x86_string_op(op: TAsmOp): boolean;
    { checks whether the specified op is an x86 parameterless string instruction
      (e.g. returns true for movsb, cmpsw, etc, but returns false for movs, cmps, etc.) }
    function is_x86_parameterless_string_op(op: TAsmOp): boolean;
    { checks whether the specified op is an x86 parameterized string instruction
      (e.g. returns true for movs, cmps, etc, but returns false for movsb, cmpsb, etc.) }
    function is_x86_parameterized_string_op(op: TAsmOp): boolean;
    function x86_parameterized_string_op_param_count(op: TAsmOp): shortint;
    function x86_param2paramless_string_op(op: TAsmOp): TAsmOp;
    function get_x86_string_op_size(op: TAsmOp): TOpSize;
    { returns the 0-based operand number (intel syntax) of the ds:[si] param of
      a x86 string instruction }
    function get_x86_string_op_si_param(op: TAsmOp):shortint;
    { returns the 0-based operand number (intel syntax) of the es:[di] param of
      a x86 string instruction }
    function get_x86_string_op_di_param(op: TAsmOp):shortint;

//   function UseAVX: boolean;
//   function UseAVX512: boolean;

implementation

    uses
      globtype,
      rgbase,verbose,
      cpuinfo;

    const
      std_regname_table : TRegNameTable = (
'INVALID',
'al',
'ah',
'ax',
'eax',
'rax',
'cl',
'ch',
'cx',
'ecx',
'rcx',
'dl',
'dh',
'dx',
'edx',
'rdx',
'bl',
'bh',
'bx',
'ebx',
'rbx',
'sil',
'si',
'esi',
'rsi',
'dil',
'di',
'edi',
'rdi',
'bpl',
'bp',
'ebp',
'rbp',
'spl',
'sp',
'esp',
'rsp',
'r8',
'r8b',
'r8w',
'r8d',
'r9',
'r9b',
'r9w',
'r9d',
'r10',
'r10b',
'r10w',
'r10d',
'r11',
'r11b',
'r11w',
'r11d',
'r12',
'r12b',
'r12w',
'r12d',
'r13',
'r13b',
'r13w',
'r13d',
'r14',
'r14b',
'r14w',
'r14d',
'r15',
'r15b',
'r15w',
'r15d',
'es',
'cs',
'ss',
'ds',
'fs',
'gs',
'flags',
'eflags',
'rflags',
'carryflag',
'parityflag',
'auxiliaryflag',
'zeroflag',
'signflag',
'overflowflag',
'interruptflag',
'directionflag',
'rip',
'eip',
'dr0',
'dr1',
'dr2',
'dr3',
'dr6',
'dr7',
'cr0',
'cr2',
'cr3',
'cr4',
'tr3',
'tr4',
'tr5',
'tr6',
'tr7',
'st(0)',
'st(1)',
'st(2)',
'st(3)',
'st(4)',
'st(5)',
'st(6)',
'st(7)',
'st',
'mm0',
'mm1',
'mm2',
'mm3',
'mm4',
'mm5',
'mm6',
'mm7',
'xmm0',
'xmm1',
'xmm2',
'xmm3',
'xmm4',
'xmm5',
'xmm6',
'xmm7',
'xmm8',
'xmm9',
'xmm10',
'xmm11',
'xmm12',
'xmm13',
'xmm14',
'xmm15',
'xmm16',
'xmm17',
'xmm18',
'xmm19',
'xmm20',
'xmm21',
'xmm22',
'xmm23',
'xmm24',
'xmm25',
'xmm26',
'xmm27',
'xmm28',
'xmm29',
'xmm30',
'xmm31',
'ymm0',
'ymm1',
'ymm2',
'ymm3',
'ymm4',
'ymm5',
'ymm6',
'ymm7',
'ymm8',
'ymm9',
'ymm10',
'ymm11',
'ymm12',
'ymm13',
'ymm14',
'ymm15',
'ymm16',
'ymm17',
'ymm18',
'ymm19',
'ymm20',
'ymm21',
'ymm22',
'ymm23',
'ymm24',
'ymm25',
'ymm26',
'ymm27',
'ymm28',
'ymm29',
'ymm30',
'ymm31',
'zmm0',
'zmm1',
'zmm2',
'zmm3',
'zmm4',
'zmm5',
'zmm6',
'zmm7',
'zmm8',
'zmm9',
'zmm10',
'zmm11',
'zmm12',
'zmm13',
'zmm14',
'zmm15',
'zmm16',
'zmm17',
'zmm18',
'zmm19',
'zmm20',
'zmm21',
'zmm22',
'zmm23',
'zmm24',
'zmm25',
'zmm26',
'zmm27',
'zmm28',
'zmm29',
'zmm30',
'zmm31',
'k0',
'k1',
'k2',
'k3',
'k4',
'k5',
'k6',
'k7'
      );
      regnumber_index : array[tregisterindex] of tregisterindex = (
0,
1,
6,
11,
16,
21,
25,
29,
33,
38,
42,
46,
50,
54,
58,
62,
66,
2,
7,
12,
17,
3,
8,
13,
18,
22,
26,
30,
34,
39,
43,
47,
51,
55,
59,
63,
67,
4,
9,
14,
19,
23,
27,
31,
35,
40,
44,
48,
52,
56,
60,
64,
68,
5,
10,
15,
20,
24,
28,
32,
36,
37,
41,
45,
49,
53,
57,
61,
65,
103,
104,
105,
106,
107,
108,
109,
110,
111,
112,
113,
114,
115,
116,
117,
118,
119,
120,
121,
122,
123,
124,
125,
126,
127,
128,
129,
130,
131,
132,
133,
134,
135,
136,
137,
138,
139,
140,
141,
142,
143,
144,
145,
146,
147,
148,
149,
150,
151,
152,
153,
154,
155,
156,
157,
158,
159,
160,
161,
162,
163,
164,
165,
166,
167,
168,
169,
170,
171,
172,
173,
174,
175,
176,
177,
178,
179,
180,
181,
182,
183,
184,
185,
186,
187,
188,
189,
190,
191,
192,
193,
194,
195,
196,
197,
198,
199,
200,
201,
202,
203,
204,
205,
206,
207,
208,
209,
210,
211,
212,
213,
214,
215,
69,
70,
71,
72,
73,
74,
88,
89,
90,
91,
92,
93,
94,
95,
96,
97,
98,
99,
100,
101,
102,
75,
76,
87,
77,
86,
78,
79,
80,
81,
82,
83,
84,
85,
216,
217,
218,
219,
220,
221,
222,
223
      );
      std_regname_index : array[tregisterindex] of tregisterindex = (
0,
2,
1,
80,
3,
17,
16,
30,
29,
18,
78,
7,
6,
94,
95,
96,
97,
70,
8,
12,
26,
25,
85,
11,
88,
89,
90,
91,
92,
93,
72,
13,
4,
31,
19,
9,
27,
14,
76,
87,
69,
23,
35,
75,
73,
74,
84,
216,
217,
218,
219,
220,
221,
222,
223,
112,
113,
114,
115,
116,
117,
118,
119,
83,
79,
45,
46,
48,
47,
49,
50,
52,
51,
53,
54,
56,
55,
57,
58,
60,
59,
61,
62,
64,
63,
65,
66,
68,
67,
37,
38,
40,
39,
41,
42,
44,
43,
5,
32,
20,
10,
28,
15,
77,
86,
24,
36,
22,
82,
21,
34,
33,
71,
111,
103,
104,
105,
106,
107,
108,
109,
110,
98,
99,
100,
101,
102,
120,
121,
130,
131,
132,
133,
134,
135,
136,
137,
138,
139,
122,
140,
141,
142,
143,
144,
145,
146,
147,
148,
149,
123,
150,
151,
124,
125,
126,
127,
128,
129,
152,
153,
162,
163,
164,
165,
166,
167,
168,
169,
170,
171,
154,
172,
173,
174,
175,
176,
177,
178,
179,
180,
181,
155,
182,
183,
156,
157,
158,
159,
160,
161,
81,
184,
185,
194,
195,
196,
197,
198,
199,
200,
201,
202,
203,
186,
204,
205,
206,
207,
208,
209,
210,
211,
212,
213,
187,
214,
215,
188,
189,
190,
191,
192,
193
      );

{*****************************************************************************
                                  Helpers
*****************************************************************************}

    function cgsize2subreg(regtype: tregistertype; s:Tcgsize):Tsubregister;
      begin
        case s of
          OS_8,OS_S8:
            cgsize2subreg:=R_SUBL;
          OS_16,OS_S16:
            cgsize2subreg:=R_SUBW;
          OS_32,OS_S32:
            cgsize2subreg:=R_SUBD;
          OS_64,OS_S64:
            cgsize2subreg:=R_SUBQ;
          OS_M64:
            cgsize2subreg:=R_SUBNONE;
          OS_F32,OS_F64,OS_C64:
            case regtype of
              R_FPUREGISTER:
                cgsize2subreg:=R_SUBWHOLE;
              R_MMREGISTER:
                case s of
                  OS_F32:
                    cgsize2subreg:=R_SUBMMS;
                  OS_F64:
                    cgsize2subreg:=R_SUBMMD;
                  else
                    internalerror(2009071901);
                end;
              else
                internalerror(2009071902);
            end;
          OS_M128:
            cgsize2subreg:=R_SUBMMX;
          OS_M256:
            cgsize2subreg:=R_SUBMMY;
          OS_M512:
            cgsize2subreg:=R_SUBMMZ;
          OS_S128,
          OS_128,
          OS_NO:
            { error message should have been thrown already before, so avoid only
              an internal error }
            cgsize2subreg:=R_SUBNONE;
          else
            internalerror(200301231);
        end;
      end;

    function reg_cgsize(const reg: tregister): tcgsize;
      const subreg2cgsize:array[Tsubregister] of Tcgsize =
            (OS_NO,OS_8,OS_8,OS_16,OS_32,OS_64,OS_NO,OS_NO,OS_NO,OS_F32,OS_F64,OS_NO,OS_M128,OS_M256,OS_M512,OS_NO,OS_NO,OS_NO,OS_NO,OS_NO,OS_NO,OS_NO,OS_NO,OS_NO);
      begin
        case getregtype(reg) of
          R_INTREGISTER :
            reg_cgsize:=subreg2cgsize[getsubreg(reg)];
          R_FPUREGISTER :
            reg_cgsize:=OS_F80;
          R_MMXREGISTER:
            reg_cgsize:=OS_M64;
          R_MMREGISTER:
            reg_cgsize:=subreg2cgsize[getsubreg(reg)];
          R_SPECIALREGISTER :
            case reg of
              NR_CS,NR_DS,NR_ES,NR_SS,NR_FS,NR_GS:
                reg_cgsize:=OS_16;
              NR_DR0..NR_TR7:
                reg_cgsize:=OS_64;
              else
                reg_cgsize:=OS_32
            end;
          R_ADDRESSREGISTER:
            case reg of
              NR_K0..NR_K7: reg_cgsize:=OS_NO;
              else internalerror(2003031801);
            end;
          else
            internalerror(2003031802);
          end;
        end;

    function reg2opsize(r:Tregister):topsize;
      const
        subreg2opsize : array[tsubregister] of topsize =
          (S_NO,S_B,S_B,S_W,S_L,S_Q,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_NO);
      begin
        reg2opsize:=S_L;
        case getregtype(r) of
          R_INTREGISTER :
            reg2opsize:=subreg2opsize[getsubreg(r)];
          R_FPUREGISTER :
            reg2opsize:=S_FL;
          R_MMXREGISTER,
          R_MMREGISTER :
            reg2opsize:=S_MD;
          R_SPECIALREGISTER :
            begin
              case r of
                NR_CS,NR_DS,NR_ES,
                NR_SS,NR_FS,NR_GS :
                  reg2opsize:=S_W;
                else
                  ;
              end;
            end;
          else
            internalerror(200303181);
        end;
      end;

    function is_calljmp(o:tasmop):boolean;
      begin
        case o of
          A_CALL,
          A_JECXZ,
          A_JRCXZ,
          A_JMP,
          A_LOOP,
          A_LOOPE,
          A_LOOPNE,
          A_LOOPNZ,
          A_LOOPZ,
          A_LCALL,
          A_LJMP,
          A_Jcc :
            is_calljmp:=true;
          else
            is_calljmp:=false;
        end;
      end;

    function is_calljmpuncondret(o:tasmop):boolean; {$ifdef USEINLINE}inline;{$endif USEINLINE}
      begin
        case o of
          A_CALL,
          A_JMP,
          A_RET,
          A_LCALL,
          A_LJMP:
            Result:=true;
          else
            Result:=false;
        end;
      end;

    procedure inverse_flags(var f: TResFlags);
      const
        inv_flags: array[TResFlags] of TResFlags =
          (F_NE,F_E,F_LE,F_GE,F_L,F_G,F_NC,F_C,
           F_BE,F_B,F_AE,F_A,
           F_NS,F_S,F_NO,F_O,
           F_FNE,F_FE,F_FBE,F_FB,F_FAE,F_FA);
      begin
        f:=inv_flags[f];
      end;

    function flags_to_cond(const f: TResFlags) : TAsmCond;
      const
        flags_2_cond : array[TResFlags] of TAsmCond =
          (C_E,C_NE,C_G,C_L,C_GE,C_LE,C_C,C_NC,C_A,C_AE,C_B,C_BE,C_S,C_NS,C_O,C_NO,
           C_None,C_None,C_None,C_None,C_None,C_None);
      begin
        result := flags_2_cond[f];
        if (result=C_None) then
          InternalError(2014041302);
      end;

    function is_segment_reg(r:tregister):boolean;
      begin
        case r of
          NR_CS,NR_DS,NR_ES,
          NR_SS,NR_FS,NR_GS :
            result:=true;
          else
            result:=false;
        end;
      end;

    function findreg_by_number(r:Tregister):tregisterindex;
      var
        hr : tregister;
      begin
        { for the name the sub reg doesn't matter }
        hr:=r;
        if (getregtype(hr)=R_MMREGISTER) and
           (getsubreg(hr)<>R_SUBMMY) and
           (getsubreg(hr)<>R_SUBMMZ) then
          setsubreg(hr,R_SUBMMX);
        result:=findreg_by_number_table(hr,regnumber_index);
      end;

    function std_regnum_search(const s:string):Tregister;
      begin
        result:=regnumber_table[findreg_by_name_table(s,std_regname_table,std_regname_index)];
      end;

    function std_regname(r:Tregister):string;
      var
        p : tregisterindex;
      begin
        if (getregtype(r)=R_MMXREGISTER) or
          ((getregtype(r)=R_MMREGISTER) and not(getsubreg(r) in [R_SUBMMX,R_SUBMMY])) then
          r:=newreg(getregtype(r),getsupreg(r),R_SUBNONE);
        p:=findreg_by_number(r);
        if p<>0 then
          result:=std_regname_table[p]
        else
          result:=generic_regname(r);
      end;

    function inverse_cond(const c: TAsmCond): TAsmCond; {$ifdef USEINLINE}inline;{$endif USEINLINE}
      const
        inverse: array[TAsmCond] of TAsmCond=(C_None,
          C_NA,C_NAE,C_NB,C_NBE,C_NC,C_NE,C_NG,C_NGE,C_NL,C_NLE,C_A,C_AE,
          C_B,C_BE,C_C,C_E,C_G,C_GE,C_L,C_LE,C_O,C_P,
          C_S,C_Z,C_NO,C_NP,C_NP,C_P,C_NS,C_NZ
        );
      begin
        result := inverse[c];
      end;

    function conditions_equal(const c1, c2: TAsmCond): boolean; {$ifdef USEINLINE}inline;{$endif USEINLINE}
      begin
        result := c1 = c2;
      end;

    { Checks if Subset is a subset of c (e.g. "less than" is a subset of "less than or equal" }
    function condition_in(const Subset, c: TAsmCond): Boolean;
      begin
        Result := (c = C_None) or conditions_equal(Subset, c);
        if not Result then
          case Subset of
            C_A,  C_NBE:
              Result := (c in [C_A,  C_AE, C_NB, C_NC, C_NBE,C_NE, C_NZ]);
            C_AE, C_NB, C_NC:
              { C_A  / C_NBE: CF = 0 and ZF = 0; not a subset because ZF has to be zero as well
                C_AE / C_NB:  CF = 0 }
              Result := (c in [C_AE, C_NB, C_NC]);
            C_B,  C_C,  C_NAE:
              { C_B  / C_NAE: CF = 1
                C_BE / C_NA:  CF = 1 or ZF = 1 }
              Result := (c in [C_B,  C_BE, C_C,  C_NA, C_NAE]);
            C_BE, C_NA:
              Result := (c in [C_BE, C_NA]);
            C_E,  C_Z:
              Result := (c in [C_AE, C_BE, C_E,  C_NA, C_NG, C_Z]);
            C_G,  C_NLE:
              { Not-equal can be considered equivalent to less than or greater than }
              Result := (c in [C_G,  C_GE, C_NE, C_NL, C_NLE,C_NZ]);
            C_GE, C_NL:
              Result := (c in [C_GE, C_NL]);
            C_L,  C_NGE:
              Result := (c in [C_L,  C_LE, C_NE, C_NG, C_NGE,C_NZ]);
            C_LE, C_NG:
              Result := (c in [C_LE, C_NG]);
            C_NE, C_NZ:
              { Note that not equal is NOT a subset of greater/less than because
                not equal is less than OR greater than. Same with above and below }
              Result := (c in [C_NE, C_NZ]);
            C_NP, C_PO:
              Result := (c in [C_NP, C_PO]);
            C_P,  C_PE:
              Result := (c in [C_P,  C_PE]);
            else
              Result := False;
          end;
      end;

    function eh_return_data_regno(nr: longint): longint;
      begin
         case nr of
           0: result:=0;
           1: result:=1;
           else
             result:=-1;
         end;
      end;

    function segment_regs_equal(r1, r2: tregister): boolean;
      begin
        if not is_segment_reg(r1) or not is_segment_reg(r2) then
          internalerror(2013062301);
        { every segment register is equal to itself }
        if r1=r2 then
          exit(true);
        { DS=SS=ES }
        if ((r1=NR_DS) or (r1=NR_SS) or (r1=NR_ES)) and
           ((r2=NR_DS) or (r2=NR_SS) or (r2=NR_ES)) then
          exit(true);
        { the remaining are distinct from each other }
        exit(false);
      end;

    function is_x86_string_op(op: TAsmOp): boolean;
      begin
        case op of
          A_MOVSQ,
          A_CMPSQ,
          A_SCASQ,
          A_LODSQ,
          A_STOSQ,
          A_MOVSB,A_MOVSW,A_MOVSD,
          A_CMPSB,A_CMPSW,A_CMPSD,
          A_SCASB,A_SCASW,A_SCASD,
          A_LODSB,A_LODSW,A_LODSD,
          A_STOSB,A_STOSW,A_STOSD,
          A_INSB, A_INSW, A_INSD,
          A_OUTSB,A_OUTSW,A_OUTSD,
          A_MOVS,A_CMPS,A_SCAS,A_LODS,A_STOS,A_INS,A_OUTS:
            result:=true;
          else
            result:=false;
        end;
      end;

    function is_x86_parameterless_string_op(op: TAsmOp): boolean;
      begin
        case op of
          A_MOVSQ,
          A_CMPSQ,
          A_SCASQ,
          A_LODSQ,
          A_STOSQ,
          A_MOVSB,A_MOVSW,A_MOVSD,
          A_CMPSB,A_CMPSW,A_CMPSD,
          A_SCASB,A_SCASW,A_SCASD,
          A_LODSB,A_LODSW,A_LODSD,
          A_STOSB,A_STOSW,A_STOSD,
          A_INSB, A_INSW, A_INSD,
          A_OUTSB,A_OUTSW,A_OUTSD:
            result:=true;
          else
            result:=false;
        end;
      end;

    function is_x86_parameterized_string_op(op: TAsmOp): boolean;
      begin
        case op of
          A_MOVS,A_CMPS,A_SCAS,A_LODS,A_STOS,A_INS,A_OUTS:
            result:=true;
          else
            result:=false;
        end;
      end;

    function x86_parameterized_string_op_param_count(op: TAsmOp): shortint;
      begin
        case op of
          A_MOVS,A_CMPS,A_INS,A_OUTS:
            result:=2;
          A_SCAS,A_LODS,A_STOS:
            result:=1;
          else
            internalerror(2017101203);
        end;
      end;

    function x86_param2paramless_string_op(op: TAsmOp): TAsmOp;
      begin
        case op of
          A_MOVSB,A_MOVSW,A_MOVSD{$ifdef x86_64},A_MOVSQ{$endif}:
            result:=A_MOVS;
          A_CMPSB,A_CMPSW,A_CMPSD{$ifdef x86_64},A_CMPSQ{$endif}:
            result:=A_CMPS;
          A_SCASB,A_SCASW,A_SCASD{$ifdef x86_64},A_SCASQ{$endif}:
            result:=A_SCAS;
          A_LODSB,A_LODSW,A_LODSD{$ifdef x86_64},A_LODSQ{$endif}:
            result:=A_LODS;
          A_STOSB,A_STOSW,A_STOSD{$ifdef x86_64},A_STOSQ{$endif}:
            result:=A_STOS;
          A_INSB, A_INSW, A_INSD:
            result:=A_INS;
          A_OUTSB,A_OUTSW,A_OUTSD:
            result:=A_OUTS;
          else
            internalerror(2017101201);
        end;
      end;

    function get_x86_string_op_size(op: TAsmOp): TOpSize;
      begin
        case op of
          A_MOVSB,A_CMPSB,A_SCASB,A_LODSB,A_STOSB,A_INSB,A_OUTSB:
            result:=S_B;
          A_MOVSW,A_CMPSW,A_SCASW,A_LODSW,A_STOSW,A_INSW,A_OUTSW:
            result:=S_W;
          A_MOVSD,A_CMPSD,A_SCASD,A_LODSD,A_STOSD,A_INSD,A_OUTSD:
            result:=S_L;
          A_MOVSQ,A_CMPSQ,A_SCASQ,A_LODSQ,A_STOSQ:
            result:=S_Q;
          else
            internalerror(2017101202);
        end;
      end;

    function get_x86_string_op_si_param(op: TAsmOp):shortint;
      begin
        case op of
          A_MOVS,A_OUTS:
            result:=1;
          A_CMPS,A_LODS:
            result:=0;
          A_SCAS,A_STOS,A_INS:
            result:=-1;
          else
            internalerror(2017101102);
        end;
      end;

    function get_x86_string_op_di_param(op: TAsmOp):shortint;
      begin
        case op of
          A_MOVS,A_SCAS,A_STOS,A_INS:
            result:=0;
          A_CMPS:
            result:=1;
          A_LODS,A_OUTS:
            result:=-1;
          else
            internalerror(2017101204);
        end;
      end;

end.
