{
    Copyright (c) 1998-2002 by Florian Klaempfl

    This unit contains the i386 AT&T instruction tables

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************
}
unit itcpugas;

{$i fpcdefs.inc}

interface

    uses
      cgbase,cpubase;

    type
      TAttSuffix = (AttSufNONE,AttSufINT,AttSufFPU,AttSufFPUint,AttSufINTdual,AttSufMM,AttSufMMX,AttSufMMS);

    const
      { include mnemonic strings }
      gas_op2str:op2strtable=
(
'NONE',
'ADC',
'ADD',
'AND',
'BSF',
'BSR',
'BSWAP',
'BT',
'BTC',
'BTR',
'BTS',
'CALL',
'CBTW',
'CLTD',
'CLC',
'CLD',
'CLI',
'CLTS',
'CMC',
'CMP',
'CMPSB',
'CMPSL',
'CMPSW',
'CMPXCHG',
'CMPXCHG486',
'CMPXCHG8B',
'CPUID',
'CWD',
'CWTL',
'DEC',
'DIV',
'EMMS',
'ENTER',
'F2XM1',
'FABS',
'FADD',
'FADDP',
'FBLD',
'FBSTP',
'FCHS',
'FCLEX',
'FCMOVB',
'FCMOVBE',
'FCMOVE',
'FCMOVNB',
'FCMOVNBE',
'FCMOVNE',
'FCMOVNU',
'FCMOVU',
'FCOM',
'FCOMI',
'FCOMIP',
'FCOMP',
'FCOMPP',
'FCOS',
'FDECSTP',
'FDISI',
'FDIV',
'FDIVP',
'FDIVR',
'FDIVRP',
'FEMMS',
'FENI',
'FFREE',
'FIADD',
'FICOM',
'FICOMP',
'FIDIV',
'FIDIVR',
'FILD',
'FIMUL',
'FINCSTP',
'FINIT',
'FIST',
'FISTP',
'FISTTP',
'FISUB',
'FISUBR',
'FLD',
'FLD1',
'FLDCW',
'FLDENV',
'FLDL2E',
'FLDL2T',
'FLDLG2',
'FLDLN2',
'FLDPI',
'FLDZ',
'FMUL',
'FMULP',
'FNCLEX',
'FNDISI',
'FNENI',
'FNINIT',
'FNOP',
'FNSAVE',
'FNSTCW',
'FNSTENV',
'FNSTSW',
'FPATAN',
'FPREM',
'FPREM1',
'FPTAN',
'FRNDINT',
'FRSTOR',
'FSAVE',
'FSCALE',
'FSETPM',
'FSIN',
'FSINCOS',
'FSQRT',
'FST',
'FSTCW',
'FSTENV',
'FSTP',
'FSTSW',
'FSUB',
'FSUBP',
'FSUBR',
'FSUBRP',
'FTST',
'FUCOM',
'FUCOMI',
'FUCOMIP',
'FUCOMP',
'FUCOMPP',
'FWAIT',
'FXAM',
'FXCH',
'FXTRACT',
'FYL2X',
'FYL2XP1',
'HLT',
'IBTS',
'ICEBP',
'IDIV',
'IMUL',
'IN',
'INC',
'INSB',
'INSL',
'INSW',
'INT',
'INT01',
'INT1',
'INT03',
'INT3',
'INVD',
'INVLPG',
'IRET',
'IRET',
'IRETW',
'IRETQ',
'JECXZ',
'JRCXZ',
'JMP',
'LAHF',
'LAR',
'LCALL',
'LEA',
'LEAVE',
'LFS',
'LGDT',
'LGS',
'LIDT',
'LJMP',
'LLDT',
'LMSW',
'LOADALL',
'LOADALL286',
'LOCK',
'LODSB',
'LODSL',
'LODSW',
'LOOP',
'LOOPE',
'LOOPNE',
'LOOPNZ',
'LOOPZ',
'LSL',
'LSS',
'LTR',
'MONITOR',
'MOV',
'MOVD',
'MOVQ',
'MOVSB',
'MOVSL',
'MOVSQ',
'MOVSW',
'MOVS',
'MOVZ',
'MUL',
'MWAIT',
'NEG',
'NOP',
'NOT',
'OR',
'OUT',
'OUTSB',
'OUTSL',
'OUTSW',
'PACKSSDW',
'PACKSSWB',
'PACKUSWB',
'PADDB',
'PADDD',
'PADDSB',
'PADDSIW',
'PADDSW',
'PADDUSB',
'PADDUSW',
'PADDW',
'PAND',
'PANDN',
'PAVEB',
'PAVGUSB',
'PCMPEQB',
'PCMPEQD',
'PCMPEQW',
'PCMPGTB',
'PCMPGTD',
'PCMPGTW',
'PDISTIB',
'PF2ID',
'PFACC',
'PFADD',
'PFCMPEQ',
'PFCMPGE',
'PFCMPGT',
'PFMAX',
'PFMIN',
'PFMUL',
'PFRCP',
'PFRCPIT1',
'PFRCPIT2',
'PFRSQIT1',
'PFRSQRT',
'PFSUB',
'PFSUBR',
'PI2FD',
'PMACHRIW',
'PMADDWD',
'PMAGW',
'PMULHRIW',
'PMULHRWA',
'PMULHRWC',
'PMULHW',
'PMULLW',
'PMVGEZB',
'PMVLZB',
'PMVNZB',
'PMVZB',
'POP',
'POPF',
'POPFW',
'POPFQ',
'POR',
'PREFETCH',
'PREFETCHW',
'PSLLD',
'PSLLDQ',
'PSLLQ',
'PSLLW',
'PSRAD',
'PSRAW',
'PSRLD',
'PSRLQ',
'PSRLW',
'PSUBB',
'PSUBD',
'PSUBSB',
'PSUBSIW',
'PSUBSW',
'PSUBUSB',
'PSUBUSW',
'PSUBW',
'PUNPCKHBW',
'PUNPCKHDQ',
'PUNPCKHWD',
'PUNPCKLBW',
'PUNPCKLDQ',
'PUNPCKLWD',
'PUSH',
'PUSHF',
'PUSHFW',
'PUSHFQ',
'PXOR',
'RCL',
'RCR',
'RDSHR',
'RDMSR',
'RDPMC',
'RDTSC',
'REP',
'REPE',
'REPNE',
'REPNZ',
'REPZ',
'RET',
'LRET',
'RET',
'RETW',
'LRETW',
'RETW',
'LRET',
'RET',
'LRETQ',
'RET',
'ROL',
'ROR',
'RSDC',
'RSLDT',
'RSM',
'SAHF',
'SAL',
'SAR',
'SBB',
'SCASB',
'SCASL',
'SCASQ',
'SCASW',
'CS',
'DS',
'ES',
'FS',
'GS',
'SS',
'SGDT',
'SHL',
'SHLD',
'SHR',
'SHRD',
'SIDT',
'SLDT',
'SMI',
'SMINT',
'SMINTOLD',
'SMSW',
'STC',
'STD',
'STI',
'STOSB',
'STOSL',
'STOSW',
'STR',
'SUB',
'SVDC',
'SVLDT',
'SVTS',
'SYSCALL',
'SYSENTER',
'SYSEXIT',
'SYSRET',
'TEST',
'UD1',
'UD2',
'UMOV',
'VERR',
'VERW',
'WAIT',
'WBINVD',
'WRSHR',
'WRMSR',
'XADD',
'XBTS',
'XCHG',
'XLAT',
'XLATB',
'XOR',
'XSTORE',
'XCRYPTECB',
'XCRYPTCBC',
'XCRYPTCFB',
'XCRYPTOFB',
'CMOV',
'J',
'SET',
'MOVS',
'CMPS',
'SCAS',
'LODS',
'STOS',
'INS',
'OUTS',
'ADDPS',
'ADDSS',
'ANDNPS',
'ANDPS',
'CMPEQPS',
'CMPEQSS',
'CMPLEPS',
'CMPLESS',
'CMPLTPS',
'CMPLTSS',
'CMPNEQPS',
'CMPNEQSS',
'CMPNLEPS',
'CMPNLESS',
'CMPNLTPS',
'CMPNLTSS',
'CMPORDPS',
'CMPORDSS',
'CMPUNORDPS',
'CMPUNORDSS',
'CMPPS',
'CMPSS',
'COMISS',
'CVTPI2PS',
'CVTPS2PI',
'CVTSI2SS',
'CVTSS2SI',
'CVTTPS2PI',
'CVTTSS2SI',
'DIVPS',
'DIVSS',
'LDMXCSR',
'MAXPS',
'MAXSS',
'MINPS',
'MINSS',
'MOVAPS',
'MOVHPS',
'MOVLHPS',
'MOVLPS',
'MOVHLPS',
'MOVMSKPS',
'MOVNTPS',
'MOVSS',
'MOVUPS',
'MULPS',
'MULSS',
'ORPS',
'RCPPS',
'RCPSS',
'RSQRTPS',
'RSQRTSS',
'SHUFPS',
'SQRTPS',
'SQRTSS',
'STMXCSR',
'SUBPS',
'SUBSS',
'UCOMISS',
'UNPCKHPS',
'UNPCKLPS',
'XORPS',
'FXRSTOR',
'FXSAVE',
'PREFETCHNTA',
'PREFETCHT0',
'PREFETCHT1',
'PREFETCHT2',
'SFENCE',
'MASKMOVQ',
'MOVNTQ',
'PAVGB',
'PAVGW',
'PEXTRW',
'PINSRW',
'PMAXSW',
'PMAXUB',
'PMINSW',
'PMINUB',
'PMOVMSKB',
'PMULHUW',
'PSADBW',
'PSHUFW',
'PFNACC',
'PFPNACC',
'PI2FW',
'PF2IW',
'PSWAPD',
'FFREEP',
'MASKMOVDQU',
'CLFLUSH',
'MOVNTDQ',
'MOVNTI',
'MOVNTPD',
'PAUSE',
'LFENCE',
'MFENCE',
'MOVDQA',
'MOVDQU',
'MOVDQ2Q',
'MOVQ2DQ',
'PADDQ',
'PMULUDQ',
'PSHUFD',
'PSHUFHW',
'PSHUFLW',
'PSRLDQ',
'PSUBQ',
'PUNPCKHQDQ',
'PUNPCKLQDQ',
'ADDPD',
'ADDSD',
'ANDNPD',
'ANDPD',
'CMPEQPD',
'CMPEQSD',
'CMPLEPD',
'CMPLESD',
'CMPLTPD',
'CMPLTSD',
'CMPNEQPD',
'CMPNEQSD',
'CMPNLEPD',
'CMPNLESD',
'CMPNLTPD',
'CMPNLTSD',
'CMPORDPD',
'CMPORDSD',
'CMPUNORDPD',
'CMPUNORDSD',
'CMPPD',
'COMISD',
'CVTDQ2PD',
'CVTDQ2PS',
'CVTPD2DQ',
'CVTPD2PI',
'CVTPD2PS',
'CVTPI2PD',
'CVTPS2DQ',
'CVTPS2PD',
'CVTSD2SI',
'CVTSD2SS',
'CVTSI2SD',
'CVTSS2SD',
'CVTTPD2PI',
'CVTTPD2DQ',
'CVTTPS2DQ',
'CVTTSD2SI',
'DIVPD',
'DIVSD',
'MAXPD',
'MAXSD',
'MINPD',
'MINSD',
'MOVAPD',
'MOVHPD',
'MOVLPD',
'MOVMSKPD',
'MOVUPD',
'MULPD',
'MULSD',
'ORPD',
'SHUFPD',
'SQRTPD',
'SQRTSD',
'SUBPD',
'SUBSD',
'UCOMISD',
'UNPCKHPD',
'UNPCKLPD',
'XORPD',
'ADDSUBPD',
'ADDSUBPS',
'HADDPD',
'HADDPS',
'HSUBPD',
'HSUBPS',
'LDDQU',
'MOVDDUP',
'MOVSHDUP',
'MOVSLDUP',
'VMREAD',
'VMWRITE',
'VMCALL',
'VMLAUNCH',
'VMRESUME',
'VMXOFF',
'VMXON',
'VMCLEAR',
'VMPTRLD',
'VMPTRST',
'VMRUN',
'VMMCALL',
'VMLOAD',
'VMSAVE',
'STGI',
'CLGI',
'SKINIT',
'INVLPGA',
'MONTMUL',
'XSHA1',
'XSHA256',
'DMINT',
'RDM',
'MOVABS',
'MOVSLQ',
'CQTO',
'CLTQ',
'CMPXCHG16B',
'MOVNTSS',
'MOVNTSD',
'INSERTQ',
'EXTRQ',
'LZCNT',
'PABSB',
'PABSW',
'PABSD',
'PALIGNR',
'PHADDW',
'PHADDD',
'PHADDSW',
'PHSUBW',
'PHSUBD',
'PHSUBSW',
'PMADDUBSW',
'PMULHRSW',
'PSHUFB',
'PSIGNB',
'PSIGNW',
'PSIGND',
'BLENDPS',
'BLENDPD',
'BLENDVPS',
'BLENDVPD',
'DPPS',
'DPPD',
'EXTRACTPS',
'INSERTPS',
'MOVNTDQA',
'MPSADBW',
'PACKUSDW',
'PBLENDVB',
'PBLENDW',
'PCMPEQQ',
'PEXTRB',
'PEXTRD',
'PEXTRQ',
'PHMINPOSUW',
'PINSRB',
'PINSRD',
'PINSRQ',
'PMAXSB',
'PMAXSD',
'PMAXUD',
'PMAXUW',
'PMINSB',
'PMINSD',
'PMINUW',
'PMINUD',
'PMOVSXBW',
'PMOVSXBD',
'PMOVSXBQ',
'PMOVSXWD',
'PMOVSXWQ',
'PMOVSXDQ',
'PMOVZXBW',
'PMOVZXBD',
'PMOVZXBQ',
'PMOVZXWD',
'PMOVZXWQ',
'PMOVZXDQ',
'PMULDQ',
'PMULLD',
'PTEST',
'ROUNDPS',
'ROUNDPD',
'ROUNDSS',
'ROUNDSD',
'CRC32',
'PCMPESTRI',
'PCMPESTRM',
'PCMPISTRI',
'PCMPISTRM',
'PCMPGTQ',
'POPCNT',
'AESENC',
'AESENCLAST',
'AESDEC',
'AESDECLAST',
'AESIMC',
'AESKEYGENASSIST',
'RDTSCP',
'STOSQ',
'LODSQ',
'CMPSQ',
'MOVBE',
'PCLMULQDQ',
'VADDPD',
'VADDPS',
'VADDSD',
'VADDSS',
'VADDSUBPD',
'VADDSUBPS',
'VAESDEC',
'VAESDECLAST',
'VAESENC',
'VAESENCLAST',
'VAESIMC',
'VAESKEYGENASSIST',
'VANDNPD',
'VANDNPS',
'VANDPD',
'VANDPS',
'VBLENDPD',
'VBLENDPS',
'VBLENDVPD',
'VBLENDVPS',
'VBROADCASTF128',
'VBROADCASTSD',
'VBROADCASTSS',
'VCMPEQPS',
'VCMPLTPS',
'VCMPLEPS',
'VCMPUNORDPS',
'VCMPNEQPS',
'VCMPNLTPS',
'VCMPNLEPS',
'VCMPORDPS',
'VCMPEQ_UQPS',
'VCMPNGEPS',
'VCMPNGTPS',
'VCMPFALSEPS',
'VCMPNEQ_OQPS',
'VCMPGEPS',
'VCMPGTPS',
'VCMPTRUEPS',
'VCMPEQ_OSPS',
'VCMPLT_OQPS',
'VCMPLE_OQPS',
'VCMPUNORD_SPS',
'VCMPNEQ_USPS',
'VCMPNLT_UQPS',
'VCMPNLE_UQPS',
'VCMPORD_SPS',
'VCMPEQ_USPS',
'VCMPNGE_UQPS',
'VCMPNGT_UQPS',
'VCMPFALSE_OSPS',
'VCMPNEQ_OSPS',
'VCMPGE_OQPS',
'VCMPGT_OQPS',
'VCMPTRUE_USPS',
'VCMPEQPD',
'VCMPLTPD',
'VCMPLEPD',
'VCMPUNORDPD',
'VCMPNEQPD',
'VCMPNLTPD',
'VCMPNLEPD',
'VCMPORDPD',
'VCMPEQ_UQPD',
'VCMPNGEPD',
'VCMPNGTPD',
'VCMPFALSEPD',
'VCMPNEQ_OQPD',
'VCMPGEPD',
'VCMPGTPD',
'VCMPTRUEPD',
'VCMPEQ_OSPD',
'VCMPLT_OQPD',
'VCMPLE_OQPD',
'VCMPUNORD_SPD',
'VCMPNEQ_USPD',
'VCMPNLT_UQPD',
'VCMPNLE_UQPD',
'VCMPORD_SPD',
'VCMPEQ_USPD',
'VCMPNGE_UQPD',
'VCMPNGT_UQPD',
'VCMPFALSE_OSPD',
'VCMPNEQ_OSPD',
'VCMPGE_OQPD',
'VCMPGT_OQPD',
'VCMPTRUE_USPD',
'VCMPPD',
'VCMPPS',
'VCMPSD',
'VCMPSS',
'VCOMISD',
'VCOMISS',
'VCVTDQ2PD',
'VCVTDQ2PS',
'VCVTPD2DQ',
'VCVTPD2PS',
'VCVTPH2PS',
'VCVTPS2DQ',
'VCVTPS2PD',
'VCVTPS2PH',
'VCVTSD2SI',
'VCVTSD2SS',
'VCVTSI2SD',
'VCVTSI2SS',
'VCVTSS2SD',
'VCVTSS2SI',
'VCVTTPD2DQ',
'VCVTTPS2DQ',
'VCVTTSD2SI',
'VCVTTSS2SI',
'VDIVPD',
'VDIVPS',
'VDIVSD',
'VDIVSS',
'VDPPD',
'VDPPS',
'VEXTRACTF128',
'VEXTRACTPS',
'VHADDPD',
'VHADDPS',
'VHSUBPD',
'VHSUBPS',
'VINSERTF128',
'VINSERTPS',
'VLDDQU',
'VLDMXCSR',
'VMASKMOVDQU',
'VMASKMOVPD',
'VMASKMOVPS',
'VMAXPD',
'VMAXPS',
'VMAXSD',
'VMAXSS',
'VMINPD',
'VMINPS',
'VMINSD',
'VMINSS',
'VMOVAPD',
'VMOVAPS',
'VMOVD',
'VMOVDDUP',
'VMOVDQA',
'VMOVDQU',
'VMOVHLPS',
'VMOVHPD',
'VMOVHPS',
'VMOVLHPS',
'VMOVLPD',
'VMOVLPS',
'VMOVMSKPD',
'VMOVMSKPS',
'VMOVNTDQ',
'VMOVNTDQA',
'VMOVNTPD',
'VMOVNTPS',
'VMOVQ',
'VMOVSD',
'VMOVSHDUP',
'VMOVSLDUP',
'VMOVSS',
'VMOVUPD',
'VMOVUPS',
'VMPSADBW',
'VMULPD',
'VMULPS',
'VMULSD',
'VMULSS',
'VORPD',
'VORPS',
'VPABSB',
'VPABSD',
'VPABSW',
'VPACKSSDW',
'VPACKSSWB',
'VPACKUSDW',
'VPACKUSWB',
'VPADDB',
'VPADDD',
'VPADDQ',
'VPADDSB',
'VPADDSW',
'VPADDUSB',
'VPADDUSW',
'VPADDW',
'VPALIGNR',
'VPAND',
'VPANDN',
'VPAVGB',
'VPAVGW',
'VPBLENDVB',
'VPBLENDW',
'VPCLMULQDQ',
'VPCMPEQB',
'VPCMPEQD',
'VPCMPEQQ',
'VPCMPEQW',
'VPCMPESTRI',
'VPCMPESTRM',
'VPCMPGTB',
'VPCMPGTD',
'VPCMPGTQ',
'VPCMPGTW',
'VPCMPISTRI',
'VPCMPISTRM',
'VPERM2F128',
'VPERMILPD',
'VPERMILPS',
'VPEXTRB',
'VPEXTRD',
'VPEXTRQ',
'VPEXTRW',
'VPHADDD',
'VPHADDSW',
'VPHADDW',
'VPHMINPOSUW',
'VPHSUBD',
'VPHSUBSW',
'VPHSUBW',
'VPINSRB',
'VPINSRD',
'VPINSRQ',
'VPINSRW',
'VPMADDUBSW',
'VPMADDWD',
'VPMAXSB',
'VPMAXSD',
'VPMAXSW',
'VPMAXUB',
'VPMAXUD',
'VPMAXUW',
'VPMINSB',
'VPMINSD',
'VPMINSW',
'VPMINUB',
'VPMINUD',
'VPMINUW',
'VPMOVMSKB',
'VPMOVSXBD',
'VPMOVSXBQ',
'VPMOVSXBW',
'VPMOVSXDQ',
'VPMOVSXWD',
'VPMOVSXWQ',
'VPMOVZXBD',
'VPMOVZXBQ',
'VPMOVZXBW',
'VPMOVZXDQ',
'VPMOVZXWD',
'VPMOVZXWQ',
'VPMULDQ',
'VPMULHRSW',
'VPMULHUW',
'VPMULHW',
'VPMULLD',
'VPMULLW',
'VPMULUDQ',
'VPOR',
'VPSADBW',
'VPSHUFB',
'VPSHUFD',
'VPSHUFHW',
'VPSHUFLW',
'VPSIGNB',
'VPSIGND',
'VPSIGNW',
'VPSLLD',
'VPSLLDQ',
'VPSLLQ',
'VPSLLW',
'VPSRAD',
'VPSRAW',
'VPSRLD',
'VPSRLDQ',
'VPSRLQ',
'VPSRLW',
'VPSUBB',
'VPSUBD',
'VPSUBQ',
'VPSUBSB',
'VPSUBSW',
'VPSUBUSB',
'VPSUBUSW',
'VPSUBW',
'VPTEST',
'VPUNPCKHBW',
'VPUNPCKHDQ',
'VPUNPCKHQDQ',
'VPUNPCKHWD',
'VPUNPCKLBW',
'VPUNPCKLDQ',
'VPUNPCKLQDQ',
'VPUNPCKLWD',
'VPXOR',
'VRCPPS',
'VRCPSS',
'VROUNDPD',
'VROUNDPS',
'VROUNDSD',
'VROUNDSS',
'VRSQRTPS',
'VRSQRTSS',
'VSHUFPD',
'VSHUFPS',
'VSQRTPD',
'VSQRTPS',
'VSQRTSD',
'VSQRTSS',
'VSTMXCSR',
'VSUBPD',
'VSUBPS',
'VSUBSD',
'VSUBSS',
'VTESTPD',
'VTESTPS',
'VUCOMISD',
'VUCOMISS',
'VUNPCKHPD',
'VUNPCKHPS',
'VUNPCKLPD',
'VUNPCKLPS',
'VXORPD',
'VXORPS',
'VZEROALL',
'VZEROUPPER',
'ANDN',
'BEXTR',
'BLSI',
'BLSMSK',
'BLSR',
'TZCNT',
'BZHI',
'MULX',
'PDEP',
'PEXT',
'RORX',
'SARX',
'SHLX',
'SHRX',
'ADCX',
'ADOX',
'VBROADCASTI128',
'VEXTRACTI128',
'VINSERTI128',
'VPBLENDD',
'VPBROADCASTB',
'VPBROADCASTD',
'VPBROADCASTQ',
'VPBROADCASTW',
'VPERM2I128',
'VPERMD',
'VPERMPD',
'VPERMPS',
'VPERMQ',
'VPMASKMOVD',
'VPMASKMOVQ',
'VPSLLVD',
'VPSLLVQ',
'VPSRAVD',
'VPSRLVD',
'VPSRLVQ',
'VGATHERDPD',
'VGATHERDPS',
'VGATHERQPD',
'VGATHERQPS',
'VPGATHERDD',
'VPGATHERDQ',
'VPGATHERQD',
'VPGATHERQQ',
'VFMADDPD',
'VFMADD132PD',
'VFMADD132PS',
'VFMADD132SD',
'VFMADD132SS',
'VFMADD213PD',
'VFMADD213PS',
'VFMADD213SD',
'VFMADD213SS',
'VFMADD231PD',
'VFMADD231PS',
'VFMADD231SD',
'VFMADD231SS',
'VFMADDSUB132PD',
'VFMADDSUB132PS',
'VFMADDSUB213PD',
'VFMADDSUB213PS',
'VFMADDSUB231PD',
'VFMADDSUB231PS',
'VFMSUB132PD',
'VFMSUB132PS',
'VFMSUB132SD',
'VFMSUB132SS',
'VFMSUB213PD',
'VFMSUB213PS',
'VFMSUB213SD',
'VFMSUB213SS',
'VFMSUB231PD',
'VFMSUB231PS',
'VFMSUB231SD',
'VFMSUB231SS',
'VFMSUBADD132PD',
'VFMSUBADD132PS',
'VFMSUBADD213PD',
'VFMSUBADD213PS',
'VFMSUBADD231PD',
'VFMSUBADD231PS',
'VFNMADD132PD',
'VFNMADD132PS',
'VFNMADD132SD',
'VFNMADD132SS',
'VFNMADD213PD',
'VFNMADD213PS',
'VFNMADD213SD',
'VFNMADD213SS',
'VFNMADD231PD',
'VFNMADD231PS',
'VFNMADD231SD',
'VFNMADD231SS',
'VFNMSUB132PD',
'VFNMSUB132PS',
'VFNMSUB132SD',
'VFNMSUB132SS',
'VFNMSUB213PD',
'VFNMSUB213PS',
'VFNMSUB213SD',
'VFNMSUB213SS',
'VFNMSUB231PD',
'VFNMSUB231PS',
'VFNMSUB231SD',
'VFNMSUB231SS',
'XACQUIRE',
'XRELEASE',
'XBEGIN',
'XABORT',
'XEND',
'XTEST',
'RDRAND',
'RDSEED',
'XGETBV',
'XSETBV',
'XSAVE',
'XSAVE64',
'XRSTOR',
'XRSTOR64',
'XSAVEOPT',
'XSAVEOPT64',
'PREFETCHWT1',
'KADDB',
'KADDD',
'KADDQ',
'KADDW',
'KANDB',
'KANDD',
'KANDNB',
'KANDND',
'KANDNQ',
'KANDNW',
'KANDQ',
'KANDW',
'KMOVB',
'KMOVD',
'KMOVQ',
'KMOVW',
'KNOTB',
'KNOTD',
'KNOTQ',
'KNOTW',
'KORB',
'KORD',
'KORQ',
'KORTESTB',
'KORTESTD',
'KORTESTQ',
'KORTESTW',
'KORW',
'KSHIFTLB',
'KSHIFTLD',
'KSHIFTLQ',
'KSHIFTLW',
'KSHIFTRB',
'KSHIFTRD',
'KSHIFTRQ',
'KSHIFTRW',
'KTESTB',
'KTESTD',
'KTESTQ',
'KTESTW',
'KUNPCKBW',
'KUNPCKDQ',
'KUNPCKWD',
'KXNORB',
'KXNORD',
'KXNORQ',
'KXNORW',
'KXORB',
'KXORD',
'KXORQ',
'KXORW',
'VALIGND',
'VALIGNQ',
'VBLENDMPD',
'VBLENDMPS',
'VBROADCASTF32X2',
'VBROADCASTF32X4',
'VBROADCASTF32X8',
'VBROADCASTF64X2',
'VBROADCASTF64X4',
'VBROADCASTI32X2',
'VBROADCASTI32X4',
'VBROADCASTI32X8',
'VBROADCASTI64X2',
'VBROADCASTI64X4',
'VCOMPRESSPD',
'VCOMPRESSPS',
'VCVTPD2QQ',
' VCVTPD2UDQ',
'VCVTPD2UQQ',
'VCVTPS2QQ',
'VCVTPS2UDQ',
'VCVTPS2UQQ',
'VCVTQQ2PD',
'VCVTQQ2PS',
'VCVTSD2USI',
'VCVTSS2USI',
'VCVTTPD2QQ',
'VCVTTPD2UDQ',
'VCVTTPD2UQQ',
'VCVTTPS2QQ',
'VCVTTPS2UDQ',
'VCVTTPS2UQQ',
'VCVTTSD2USI',
'VCVTTSS2USI',
'VCVTUDQ2PD',
'VCVTUDQ2PS',
'VCVTUQQ2PD',
'VCVTUQQ2PS',
'VCVTUSI2SD',
'VCVTUSI2SS',
'VDBPSADBW',
'VEXP2PD',
'VEXP2PS',
'VEXPANDPD',
'VEXPANDPS',
'VEXTRACTF32X4',
'VEXTRACTF32X8',
'VEXTRACTF64X2',
'VEXTRACTF64X4',
'VEXTRACTI32X4',
'VEXTRACTI32X8',
'VEXTRACTI64X2',
'VEXTRACTI64X4',
'VFIXUPIMMPD',
'VFIXUPIMMPS',
'VFIXUPIMMSD',
'VFIXUPIMMSS',
'VFPCLASSPD',
'VFPCLASSPS',
'VFPCLASSSD',
'VFPCLASSSS',
'VGETEXPPD',
'VGETEXPPS',
'VGETEXPSD',
'VGETEXPSS',
'VGETMANTPD',
'VGETMANTPS',
'VGETMANTSD',
'VGETMANTSS',
'VINSERTF32X4',
'VINSERTF32X8',
'VINSERTF64X2',
'VINSERTF64X4',
'VINSERTI32X4',
'VINSERTI32X8',
'VINSERTI64X2',
'VINSERTI64X4',
'VMOVDQA32',
'VMOVDQA64',
'VMOVDQU16',
'VMOVDQU32',
'VMOVDQU64',
'VMOVDQU8',
'VPABSQ',
'VPANDD',
'VPANDND',
'VPANDNQ',
'VPANDQ',
'VPBLENDMB',
'VPBLENDMD',
'VPBLENDMQ',
'VPBLENDMW',
'VPCMPB',
'VPCMPD',
'VPCMPQ',
'VPCMPUB',
'VPCMPUD',
'VPCMPUQ',
'VPCMPUW',
'VPCMPW',
'VPCOMPRESSD',
'VPCOMPRESSQ',
'VPCONFLICTD',
'VPCONFLICTQ',
'VPERMB',
'VPERMI2B',
'VPERMI2D',
'VPERMI2PD',
'VPERMI2PS',
'VPERMI2Q',
'VPERMI2W',
'VPERMT2B',
'VPERMT2D',
'VPERMT2PD',
'VPERMT2PS',
'VPERMT2Q',
'VPERMT2W',
'VPERMW',
'VPEXPANDD',
'VPEXPANDQ',
'VPLZCNTD',
'VPLZCNTQ',
'VPMADD52HUQ',
'VPMADD52LUQ',
'VPMAXSQ',
'VPMAXUQ',
'VPMINSQ',
'VPMINUQ',
'VPMOVB2M',
'VPMOVD2M',
'VPMOVDB',
'VPMOVDW',
'VPMOVM2B',
'VPMOVM2D',
'VPMOVM2Q',
'VPMOVM2W',
'VPMOVQ2M',
'VPMOVQB',
'VPMOVQD',
'VPMOVQW',
'VPMOVSDB',
'VPMOVSDW',
'VPMOVSQB',
'VPMOVSQD',
'VPMOVSQW',
'VPMOVSWB',
'VPMOVUSDB',
'VPMOVUSDW',
'VPMOVUSQB',
'VPMOVUSQD',
'VPMOVUSQW',
'VPMOVUSWB',
'VPMOVW2M',
'VPMOVWB',
'VPMULLQ',
'VPMULTISHIFTQB',
'VPORD',
'VPORQ',
'VPROLD',
'VPROLQ',
'VPROLVD',
'VPROLVQ',
'VPRORD',
'VPRORQ',
'VPRORVD',
'VPRORVQ',
'VPSCATTERDD',
'VPSCATTERDQ',
'VPSCATTERQD',
'VPSCATTERQQ',
'VPSLLVW',
'VPSRAQ',
'VPSRAVQ',
'VPSRAVW',
'VPSRLVW',
'VPTERNLOGD',
'VPTERNLOGQ',
'VPTESTMB',
'VPTESTMD',
'VPTESTMQ',
'VPTESTMW',
'VPTESTNMB',
'VPTESTNMD',
'VPTESTNMQ',
'VPTESTNMW',
'VPXORD',
'VPXORQ',
'VRANGEPD',
'VRANGEPS',
'VRANGESD',
'VRANGESS',
'VRCP14PD',
'VRCP14PS',
'VRCP14SD',
'VRCP14SS',
'VRCP28PD',
'VRCP28PS',
'VRCP28SD',
'VRCP28SS',
'VREDUCEPD',
'VREDUCEPS',
'VREDUCESD',
'VREDUCESS',
'VRNDSCALEPD',
'VRNDSCALEPS',
'VRNDSCALESD',
'VRNDSCALESS',
'VRSQRT14PD',
'VRSQRT14PS',
'VRSQRT14SD',
'VRSQRT14SS',
'VRSQRT28PD',
'VRSQRT28PS',
'VRSQRT28SD',
'VRSQRT28SS',
'VSCALEFPD',
'VSCALEFPS',
'VSCALEFSD',
'VSCALEFSS',
'VSCATTERDPD',
'VSCATTERDPS',
'VSCATTERQPD',
'VSCATTERQPS',
'VSHUFF32X4',
'VSHUFF64X2',
'VSHUFI32X4',
'VSHUFI64X2',
'VPCOMPRESSB',
'VPCOMPRESSW',
'VPDPBUSD',
'VPDPBUSDS',
'VPDPWSSD',
'VPDPWSSDS',
'VPEXPANDB',
'VPEXPANDW',
'VPOPCNTB',
'VPOPCNTD',
'VPOPCNTQ',
'VPOPCNTW',
'VPSHLDD',
'VPSHLDQ',
'VPSHLDVD',
'VPSHLDVQ',
'VPSHLDVW',
'VPSHLDW',
'VPSHRDD',
'VPSHRDQ',
'VPSHRDVD',
'VPSHRDVQ',
'VPSHRDVW',
'VPSHRDW',
'VPSHUFBITQMB',
'SHA1RNDS4',
'SHA1NEXTE',
'SHA1MSG1',
'SHA1MSG2',
'SHA256RNDS2',
'SHA256MSG1',
'SHA256MSG2'
);

gas_needsuffix:array[tasmop] of TAttSuffix=
(
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufFPU,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufNONE,
attsufNONE,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPUint,
attsufFPU,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPU,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPU,
attsufINT,
attsufNONE,
attsufFPU,
attsufINT,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufNONE,
attsufFPU,
attsufFPU,
attsufFPU,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufFPU,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINTdual,
attsufINTdual,
attsufINT,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMS,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMS,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMX,
attsufMMX,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMS,
attsufMMS,
attsufNONE,
attsufNONE,
attsufMMX,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufINT,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMX,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMX,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMX,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMX,
attsufMMS,
attsufMMS,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufMMS,
attsufMMS,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE,
attsufNONE
);

     gas_opsize2str : array[topsize] of string[2] = ('',
       'b','w','l','q','bw','bl','wl','bq','wq','lq',
       's','l','q',
       's','l','t','v','x',
       'd',
       '','','',
       't',
       'x',
       'y',
       'z'
     );
     { suffix-to-opsize conversion tables, used in asmreadrer }
     { !! S_LQ excluded: movzlq does not exist, movslq is processed
       as a separate instruction w/o suffix (aka movsxd), and there are
       no more instructions needing it. }
     att_sizesuffixstr : array[0..14] of string[2] = (
       '','BW','BL','WL','BQ','WQ',{'LQ',}'B','W','L','S','Q','T','X','Y','Z'
     );
     att_sizesuffix : array[0..14] of topsize = (
       S_NO,S_BW,S_BL,S_WL,S_BQ,S_WQ,{S_LQ,}S_B,S_W,S_L,S_NO,S_Q,S_NO,S_NO,S_NO,S_NO
     );
     att_sizefpusuffix : array[0..14] of topsize = (
       S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,{S_NO,}S_NO,S_NO,S_FL,S_FS,S_NO,S_FX,S_NO,S_NO,S_NO
     );
     att_sizefpuintsuffix : array[0..14] of topsize = (
       S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,{S_NO,}S_NO,S_NO,S_IL,S_IS,S_IQ,S_NO,S_NO,S_NO,S_NO
     );
     att_sizemmsuffix : array[0..14] of topsize = (
       S_NO,S_NO,S_NO,S_NO,S_NO, S_NO,{S_NO,}S_NO,S_NO,S_IL,S_NO,S_IQ,S_NO,S_XMM,S_YMM,S_ZMM
     );
     att_sizemmxsuffix : array[0..14] of topsize = (
       S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,{S_NO,}S_NO,S_NO,S_NO,S_NO,S_NO,S_NO,S_XMM,S_NO,S_NO
     );

    function gas_regnum_search(const s:string):Tregister;

implementation

    uses
      cutils,rgbase;

    const
      att_regname_table : TRegNameTable = (
        {r8664att.inc contains the AT&T name of each register.}
'INVALID',
'%al',
'%ah',
'%ax',
'%eax',
'%rax',
'%cl',
'%ch',
'%cx',
'%ecx',
'%rcx',
'%dl',
'%dh',
'%dx',
'%edx',
'%rdx',
'%bl',
'%bh',
'%bx',
'%ebx',
'%rbx',
'%sil',
'%si',
'%esi',
'%rsi',
'%dil',
'%di',
'%edi',
'%rdi',
'%bpl',
'%bp',
'%ebp',
'%rbp',
'%spl',
'%sp',
'%esp',
'%rsp',
'%r8',
'%r8b',
'%r8w',
'%r8d',
'%r9',
'%r9b',
'%r9w',
'%r9d',
'%r10',
'%r10b',
'%r10w',
'%r10d',
'%r11',
'%r11b',
'%r11w',
'%r11d',
'%r12',
'%r12b',
'%r12w',
'%r12d',
'%r13',
'%r13b',
'%r13w',
'%r13d',
'%r14',
'%r14b',
'%r14w',
'%r14d',
'%r15',
'%r15b',
'%r15w',
'%r15d',
'%es',
'%cs',
'%ss',
'%ds',
'%fs',
'%gs',
'%flags',
'%eflags',
'%rflags',
'%carryflag',
'%parityflag',
'%auxiliaryflag',
'%zeroflag',
'%signflag',
'%overflowflag',
'%interruptflag',
'%directionflag',
'%rip',
'%eip',
'%dr0',
'%dr1',
'%dr2',
'%dr3',
'%dr6',
'%dr7',
'%cr0',
'%cr2',
'%cr3',
'%cr4',
'%tr3',
'%tr4',
'%tr5',
'%tr6',
'%tr7',
'%st(0)',
'%st(1)',
'%st(2)',
'%st(3)',
'%st(4)',
'%st(5)',
'%st(6)',
'%st(7)',
'%st',
'%mm0',
'%mm1',
'%mm2',
'%mm3',
'%mm4',
'%mm5',
'%mm6',
'%mm7',
'%xmm0',
'%xmm1',
'%xmm2',
'%xmm3',
'%xmm4',
'%xmm5',
'%xmm6',
'%xmm7',
'%xmm8',
'%xmm9',
'%xmm10',
'%xmm11',
'%xmm12',
'%xmm13',
'%xmm14',
'%xmm15',
'%xmm16',
'%xmm17',
'%xmm18',
'%xmm19',
'%xmm20',
'%xmm21',
'%xmm22',
'%xmm23',
'%xmm24',
'%xmm25',
'%xmm26',
'%xmm27',
'%xmm28',
'%xmm29',
'%xmm30',
'%xmm31',
'%ymm0',
'%ymm1',
'%ymm2',
'%ymm3',
'%ymm4',
'%ymm5',
'%ymm6',
'%ymm7',
'%ymm8',
'%ymm9',
'%ymm10',
'%ymm11',
'%ymm12',
'%ymm13',
'%ymm14',
'%ymm15',
'%ymm16',
'%ymm17',
'%ymm18',
'%ymm19',
'%ymm20',
'%ymm21',
'%ymm22',
'%ymm23',
'%ymm24',
'%ymm25',
'%ymm26',
'%ymm27',
'%ymm28',
'%ymm29',
'%ymm30',
'%ymm31',
'%zmm0',
'%zmm1',
'%zmm2',
'%zmm3',
'%zmm4',
'%zmm5',
'%zmm6',
'%zmm7',
'%zmm8',
'%zmm9',
'%zmm10',
'%zmm11',
'%zmm12',
'%zmm13',
'%zmm14',
'%zmm15',
'%zmm16',
'%zmm17',
'%zmm18',
'%zmm19',
'%zmm20',
'%zmm21',
'%zmm22',
'%zmm23',
'%zmm24',
'%zmm25',
'%zmm26',
'%zmm27',
'%zmm28',
'%zmm29',
'%zmm30',
'%zmm31',
'%k0',
'%k1',
'%k2',
'%k3',
'%k4',
'%k5',
'%k6',
'%k7'
      );

      att_regname_index : array[tregisterindex] of tregisterindex = (
        {r8664ari.inc contains an index which sorts att_regname_table by
         ATT name.}
2,
1,
80,
3,
17,
16,
30,
29,
18,
78,
7,
6,
94,
95,
96,
97,
70,
8,
12,
26,
25,
85,
11,
88,
89,
90,
91,
92,
93,
72,
13,
4,
31,
19,
9,
27,
14,
76,
87,
69,
23,
35,
75,
73,
74,
84,
216,
217,
218,
219,
220,
221,
222,
223,
112,
113,
114,
115,
116,
117,
118,
119,
83,
79,
45,
46,
48,
47,
49,
50,
52,
51,
53,
54,
56,
55,
57,
58,
60,
59,
61,
62,
64,
63,
65,
66,
68,
67,
37,
38,
40,
39,
41,
42,
44,
43,
5,
32,
20,
10,
28,
15,
77,
86,
24,
36,
22,
82,
21,
34,
33,
71,
111,
103,
104,
105,
106,
107,
108,
109,
110,
98,
99,
100,
101,
102,
120,
121,
130,
131,
132,
133,
134,
135,
136,
137,
138,
139,
122,
140,
141,
142,
143,
144,
145,
146,
147,
148,
149,
123,
150,
151,
124,
125,
126,
127,
128,
129,
152,
153,
162,
163,
164,
165,
166,
167,
168,
169,
170,
171,
154,
172,
173,
174,
175,
176,
177,
178,
179,
180,
181,
155,
182,
183,
156,
157,
158,
159,
160,
161,
81,
184,
185,
194,
195,
196,
197,
198,
199,
200,
201,
202,
203,
186,
204,
205,
206,
207,
208,
209,
210,
211,
212,
213,
187,
214,
215,
188,
189,
190,
191,
192,
193,
0
      );

    function gas_regnum_search(const s:string):Tregister;
      begin
        result:=regnumber_table[findreg_by_name_table(s,att_regname_table,att_regname_index)];
      end;

end.
