{
    Copyright (c) 1998-2002 by Florian Klaempfl

    This unit contains the x86 instruction tables

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************
}
unit itx86int;

{$i fpcdefs.inc}

interface

    uses
      cgbase;

function asm_regnum_search(const s:string):Tregister;

implementation

    uses
      cpubase;

    const
      int_regname_table : array[tregisterindex] of string[13] = (
'INVALID',
'al',
'ah',
'ax',
'eax',
'rax',
'cl',
'ch',
'cx',
'ecx',
'rcx',
'dl',
'dh',
'dx',
'edx',
'rdx',
'bl',
'bh',
'bx',
'ebx',
'rbx',
'sil',
'si',
'esi',
'rsi',
'dil',
'di',
'edi',
'rdi',
'bpl',
'bp',
'ebp',
'rbp',
'spl',
'sp',
'esp',
'rsp',
'r8',
'r8b',
'r8w',
'r8d',
'r9',
'r9b',
'r9w',
'r9d',
'r10',
'r10b',
'r10w',
'r10d',
'r11',
'r11b',
'r11w',
'r11d',
'r12',
'r12b',
'r12w',
'r12d',
'r13',
'r13b',
'r13w',
'r13d',
'r14',
'r14b',
'r14w',
'r14d',
'r15',
'r15b',
'r15w',
'r15d',
'es',
'cs',
'ss',
'ds',
'fs',
'gs',
'flags',
'eflags',
'rflags',
'carryflag',
'parityflag',
'auxiliaryflag',
'zeroflag',
'signflag',
'overflowflag',
'interruptflag',
'directionflag',
'rip',
'eip',
'dr0',
'dr1',
'dr2',
'dr3',
'dr6',
'dr7',
'cr0',
'cr2',
'cr3',
'cr4',
'tr3',
'tr4',
'tr5',
'tr6',
'tr7',
'st(0)',
'st(1)',
'st(2)',
'st(3)',
'st(4)',
'st(5)',
'st(6)',
'st(7)',
'st',
'mm0',
'mm1',
'mm2',
'mm3',
'mm4',
'mm5',
'mm6',
'mm7',
'xmm0',
'xmm1',
'xmm2',
'xmm3',
'xmm4',
'xmm5',
'xmm6',
'xmm7',
'xmm8',
'xmm9',
'xmm10',
'xmm11',
'xmm12',
'xmm13',
'xmm14',
'xmm15',
'xmm16',
'xmm17',
'xmm18',
'xmm19',
'xmm20',
'xmm21',
'xmm22',
'xmm23',
'xmm24',
'xmm25',
'xmm26',
'xmm27',
'xmm28',
'xmm29',
'xmm30',
'xmm31',
'ymm0',
'ymm1',
'ymm2',
'ymm3',
'ymm4',
'ymm5',
'ymm6',
'ymm7',
'ymm8',
'ymm9',
'ymm10',
'ymm11',
'ymm12',
'ymm13',
'ymm14',
'ymm15',
'ymm16',
'ymm17',
'ymm18',
'ymm19',
'ymm20',
'ymm21',
'ymm22',
'ymm23',
'ymm24',
'ymm25',
'ymm26',
'ymm27',
'ymm28',
'ymm29',
'ymm30',
'ymm31',
'zmm0',
'zmm1',
'zmm2',
'zmm3',
'zmm4',
'zmm5',
'zmm6',
'zmm7',
'zmm8',
'zmm9',
'zmm10',
'zmm11',
'zmm12',
'zmm13',
'zmm14',
'zmm15',
'zmm16',
'zmm17',
'zmm18',
'zmm19',
'zmm20',
'zmm21',
'zmm22',
'zmm23',
'zmm24',
'zmm25',
'zmm26',
'zmm27',
'zmm28',
'zmm29',
'zmm30',
'zmm31',
'k0',
'k1',
'k2',
'k3',
'k4',
'k5',
'k6',
'k7'
      );

      int_regname_index : array[tregisterindex] of tregisterindex = (
0,
2,
1,
80,
3,
17,
16,
30,
29,
18,
78,
7,
6,
94,
95,
96,
97,
70,
8,
12,
26,
25,
85,
11,
88,
89,
90,
91,
92,
93,
72,
13,
4,
31,
19,
9,
27,
14,
76,
87,
69,
23,
35,
75,
73,
74,
84,
216,
217,
218,
219,
220,
221,
222,
223,
112,
113,
114,
115,
116,
117,
118,
119,
83,
79,
45,
46,
48,
47,
49,
50,
52,
51,
53,
54,
56,
55,
57,
58,
60,
59,
61,
62,
64,
63,
65,
66,
68,
67,
37,
38,
40,
39,
41,
42,
44,
43,
5,
32,
20,
10,
28,
15,
77,
86,
24,
36,
22,
82,
21,
34,
33,
71,
111,
103,
104,
105,
106,
107,
108,
109,
110,
98,
99,
100,
101,
102,
120,
121,
130,
131,
132,
133,
134,
135,
136,
137,
138,
139,
122,
140,
141,
142,
143,
144,
145,
146,
147,
148,
149,
123,
150,
151,
124,
125,
126,
127,
128,
129,
152,
153,
162,
163,
164,
165,
166,
167,
168,
169,
170,
171,
154,
172,
173,
174,
175,
176,
177,
178,
179,
180,
181,
155,
182,
183,
156,
157,
158,
159,
160,
161,
81,
184,
185,
194,
195,
196,
197,
198,
199,
200,
201,
202,
203,
186,
204,
205,
206,
207,
208,
209,
210,
211,
212,
213,
187,
214,
215,
188,
189,
190,
191,
192,
193
      );

    function findreg_by_intname(const s:string):integer;
      var
        l,r,m: integer;
      begin
        {Binary search.}
        l := 0;
        r := high(tregisterindex) + 1;
        while l < r do
          begin
            m := (l + r) div 2;
            if int_regname_table[int_regname_index[m]] < s then l := m + 1
            else r := m;
          end;

        if (r<=high(tregisterindex)) and (int_regname_table[int_regname_index[r]]=s) then
          findreg_by_intname:=int_regname_index[r]
        else
          findreg_by_intname:=0;
      end;

function asm_regnum_search(const s:string):Tregister;
begin
  result:=regnumber_table[findreg_by_intname(s)];
end;

end.
