{
    Copyright (c) 1998-2002 by Florian Klaempfl

    This unit implements the x86 specific class for the register
    allocator

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 ****************************************************************************
}

unit rgx86;

{$i fpcdefs.inc}

interface

    uses
      cgbase,cgutils,aasmdata,rgobj;

    type
       trgx86 = class(trgobj)
         function  get_spill_subreg(r : tregister) : tsubregister;override;
       end;

       tpushedsavedloc = record
         case byte of
           0: (pushed: boolean);
           1: (ofs: longint);
       end;

       tpushedsavedfpu = array[tsuperregister] of tpushedsavedloc;

       trgx86fpu = class
          used_in_proc : tcpuregisterset;
          fpuvaroffset : byte;
          constructor create;
          procedure saveusedfpuregisters(list:TAsmList;
                                         var saved:Tpushedsavedfpu;
                                         const s:Tcpuregisterset);
          function correct_fpuregister(r : tregister;ofs : byte) : tregister;
       end;

implementation

function trgx86.get_spill_subreg(r : tregister) : tsubregister;
begin
 result:=getsubreg(r);
end;

constructor Trgx86fpu.create;
begin
 used_in_proc:=[];
end;

function trgx86fpu.correct_fpuregister(r : tregister;ofs : byte) : tregister;
begin
 correct_fpuregister:=r;
 setsupreg(correct_fpuregister,ofs);
end;

procedure trgx86fpu.saveusedfpuregisters(list: TAsmList;
                                         var saved : tpushedsavedfpu;
                                         const s: tcpuregisterset);
begin
 used_in_proc:=used_in_proc+s;
end;

end.
