{
    This file is part of the Free Pascal run time library.
    Copyright (c) 1997-2004 by the Free Pascal development team

    Some x86 specific stuff. Has to be fixed still for *BSD

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY;without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

unit x86;

interface

{$MODE OBJFPC}

{$inline on}

Uses BaseUnix;

function ReadPortB (Port : Longint): Byte;inline;
function ReadPortW (Port : Longint): Word;inline;
function ReadPortL (Port : Longint): Longint;inline;
Procedure ReadPort (Port : Longint; Var Value : Byte);inline;
Procedure ReadPort (Port : Longint; Var Value : Longint);inline;
Procedure ReadPort (Port : Longint; Var Value : Word);inline;
Procedure ReadPortB (Port : Longint; Var Buf; Count: longint);
Procedure ReadPortL (Port : Longint; Var Buf; Count: longint);
Procedure ReadPortW (Port : Longint; Var Buf; Count: longint);
Procedure WritePort (Port : Longint; Value : Byte);inline;
Procedure WritePort (Port : Longint; Value : Longint);inline;
Procedure WritePort (Port : Longint; Value : Word);inline;
Procedure WritePortB (Port : Longint; Value : Byte);inline;
Procedure WritePortB (Port : Longint; Var Buf; Count: longint);
Procedure WritePortL (Port : Longint; Value : Longint);inline;
Procedure WritePortW (Port : Longint; Value : Word);inline;
Procedure WritePortW (Port : Longint; Var Buf; Count: longint);
Procedure WritePortl (Port : Longint; Var Buf; Count: longint);

Function  fpIOperm (From,Num,Value : QWord) : QWord; assembler;
Function  fpIoPL(Level : QWord) : QWord; assembler;

implementation
{$ASMMODE ATT}

Uses Syscall;

Procedure WritePort (Port : Longint; Value : Byte);inline;
{
  Writes 'Value' to port 'Port'
}
begin
  fpc_x86_outportb(Port,Value);
end;

Procedure WritePort (Port : Longint; Value : Word);inline;
{
  Writes 'Value' to port 'Port'
}

begin
  fpc_x86_outportw(Port,Value);
end;

Procedure WritePort (Port : Longint; Value : Longint);inline;
{
  Writes 'Value' to port 'Port'
}
begin
  fpc_x86_outportl(Port,Value);
end;

Procedure WritePortB (Port : Longint; Value : Byte);inline;
{
  Writes 'Value' to port 'Port'
}
begin
  fpc_x86_outportb(Port,Value);
end;

Procedure WritePortW (Port : Longint; Value : Word);inline;
{
  Writes 'Value' to port 'Port'
}

begin
  fpc_x86_outportw(Port,Value);
end;

Procedure WritePortL (Port : Longint; Value : Longint);inline;
{
  Writes 'Value' to port 'Port'
}

begin
  fpc_x86_outportl(Port,Value);
end;



Procedure WritePortl (Port : Longint; Var Buf; Count: longint);
{
  Writes 'Count' longints from 'Buf' to Port
}
begin
  asm
        movl count,%ecx
        movq buf,%rsi
        movl port,%edx
        cld
        rep
        outsl
  end;
end;

Procedure WritePortW (Port : Longint; Var Buf; Count: longint);
{
  Writes 'Count' words from 'Buf' to Port
}
begin
  asm
        movl count,%ecx
        movq buf,%rsi
        movl port,%edx
        cld
        rep
        outsw
  end;
end;

Procedure WritePortB (Port : Longint; Var Buf; Count: longint);
{
  Writes 'Count' bytes from 'Buf' to Port
}
begin
  asm
        movl count,%ecx
        movq buf,%rsi
        movl port,%edx
        cld
        rep
        outsb
  end;
end;

Procedure ReadPort (Port : Longint; Var Value : Byte);inline;
{
  Reads 'Value' from port 'Port'
}
begin
  Value:=fpc_x86_inportb(Port);
end;

Procedure ReadPort (Port : Longint; Var Value : Word);inline;
{
  Reads 'Value' from port 'Port'
}
begin
  Value:=fpc_x86_inportw(Port);
end;

Procedure ReadPort (Port : Longint; Var Value : Longint);inline;
{
  Reads 'Value' from port 'Port'
}
begin
  Value:=fpc_x86_inportl(Port);
end;

function ReadPortB (Port : Longint): Byte;inline;
{
  Reads a byte from port 'Port'
}
begin
  ReadPortB:=fpc_x86_inportb(Port);
end;

function ReadPortW (Port : Longint): Word;inline;
{
  Reads a word from port 'Port'
}
begin
  ReadPortW:=fpc_x86_inportw(Port);
end;

function ReadPortL (Port : Longint): LongInt;inline;
{
  Reads a LongInt from port 'Port'
}
begin
  ReadPortL:=fpc_x86_inportl(Port);
end;

Procedure ReadPortL (Port : Longint; Var Buf; Count: longint);
{
  Reads 'Count' longints from port 'Port' to 'Buf'.
}
begin
  asm
        movl count,%ecx
        movq buf,%rdi
        movl port,%edx
        cld
        rep
        insl
  end;
end;

Procedure ReadPortW (Port : Longint; Var Buf; Count: longint);
{
  Reads 'Count' words from port 'Port' to 'Buf'.
}
begin
  asm
        movl count,%ecx
        movq buf,%rdi
        movl port,%edx
        cld
        rep
        insw
  end;
end;

Procedure ReadPortB (Port : Longint; Var Buf; Count: longint);
{
  Reads 'Count' bytes from port 'Port' to 'Buf'.
}
begin
  asm
        movl count,%ecx
        movq buf,%rdi
        movl port,%edx
        cld
        rep
        insb
  end;
end;

{$ASMMODE INTEL}

Function  fpIOperm (From,Num ,Value : QWord) : QWord; assembler;
{
  Set permissions on NUM ports starting with port FROM to VALUE
  this works ONLY as root.
}
asm
  mov  rax, 173
  mov  rdi, from
  mov  rsi, num
  mov  rdx, value
  syscall
  mov  result,rax
end;

Function fpIoPL(Level : QWord) : QWord; assembler;
asm
  mov  rax, 172
  mov  rdi, level
  syscall
  mov  result,rax
end;

end.
